{******************************************************************************}
{                                                                              }
{ Project DSpatial - Geospatial analysis for Delphi                            }
{                                                                              }
{ The contents of this file are subject to the Mozilla Public License Version  }
{ 1.1 (the "License"); you may not use this file except in compliance with the }
{ License. You may obtain a copy of the License at http://www.mozilla.org/MPL/.}
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS" basis,   }
{ WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for }
{ the specific language governing rights and limitations under the License.    }
{                                                                              }
{ The Original Code is DSpHDFTypes.pas. The Original Code is available through }
{ the home page of DSpatial at http://dspatial.sourceforge.net.                }
{                                                                              }
{ The Initial Developer of the Original Code is Patrick Van Laake              }
{ (pvanlaake@users.sourceforge.net). Portions created by the Initial Developer }
{ are Copyright (C) of the Initial Developer. Changes to the Original Code     }
{ available through DSpatial are Copyright (C) of the Contributing Authors.    }
{                                                                              }
{******************************************************************************}
{                                                                              }
{ This unit contains some constants and types required by the HDF interface,   }
{ version 41r5.                                                                }
{                                                                              }
{ Unit owner    : Patrick Van Laake                                            }
{ Last modified : 2003 July 21                                                 }
{                                                                              }
{ Dependencies  : none                                                         }
{                                                                              }
{ Version       : 0.1  03Jul21 Initial coding. Port from an earlier code base  }
{                              developed by the Initial Developer.             }
{                                                                              }
{******************************************************************************}
unit DSpHDFTypes;

interface
const
  HDF_FAIL     = -1;
  HDF_SUCCESS  = 0;

  MAX_VAR_DIMS = 6;

  HDF_DATATYPE_SIZE : array [4..25] of integer =
     // char, single, double, ... short, byte, small, word, integer, cardinal
    (1, 4, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     1, 1, 2, 2, 4, 4);
type
  TDimsArray = array[1..MAX_VAR_DIMS] of integer;
  PDimsArray = ^TDimsArray;

  SArray = array[0..1] of single;
  DArray = array[0..1] of double;
  SHArray = array[0..1] of shortint;
  SMArray = array[0..1] of smallint;
  BArray = array[0..1] of byte;
  WArray = array[0..1] of word;
  IArray = array[0..1] of integer;
  CArray = array[0..1] of cardinal;
implementation

end.
