{******************************************************************************}
{                                                                              }
{ Project DSpatial - Geospatial analysis for Delphi                            }
{                                                                              }
{ The contents of this file are subject to the Mozilla Public License Version  }
{ 1.1 (the "License"); you may not use this file except in compliance with the }
{ License. You may obtain a copy of the License at http://www.mozilla.org/MPL/.}
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS" basis,   }
{ WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for }
{ the specific language governing rights and limitations under the License.    }
{                                                                              }
{ The Original Code is DSpLegend.pas. The Original Code is available through   }
{ the home page of DSpatial at http://dspatial.sourceforge.net.                }
{                                                                              }
{ The Initial Developer of the Original Code is Patrick Van Laake              }
{ (pvanlaake@users.sourceforge.net). Portions created by the Initial Developer }
{ are Copyright (C) of the Initial Developer. Changes to the Original Code     }
{ available through DSpatial are Copyright (C) of the Contributing Authors.    }
{                                                                              }
{******************************************************************************}
{                                                                              }
{ This unit implements the legend for use with the DSpViewer component. This   }
{ legend is itself a component, and it diplays DSpRenderer objects. The legend }
{ is not required in using the viewer, but it provides a simple mechanism for  }
{ the user to access the renderer properties, and basically any form of access }
{ to data sets loaded by the application.                                      }
{ The legend is implemented as a control, descending from TTreeView. The       }
{ legend will be installed on the DSpatial component palette page.             }
{                                                                              }
{ Unit owner    : Patrick Van Laake                                            }
{ Last modified : 2003 July 18                                                 }
{                                                                              }
{ Dependencies  : DSpRenderer                                                  }
{                 DSpGlobals                                                   }
{                 ComCtrls (TTreeView)                                         }
{                 SysUtils (Exception)                                         }
{                                                                              }
{ Version       : 0.1  03Jul18 Initial coding.                                 }
{                                                                              }
{******************************************************************************}
unit DSpLegend;
{$I DSpatial.inc}
interface
uses ComCtrls, DSpGlobals, DSpRenderer;
type
  TDSpLegend = class(TTreeView)
  private
  end;

implementation

end.
