{******************************************************************************}
{                                                                              }
{ Project DSpatial - Geospatial analysis for Delphi                            }
{                                                                              }
{ The contents of this file are subject to the Mozilla Public License Version  }
{ 1.1 (the "License"); you may not use this file except in compliance with the }
{ License. You may obtain a copy of the License at http://www.mozilla.org/MPL/.}
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS" basis,   }
{ WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for }
{ the specific language governing rights and limitations under the License.    }
{                                                                              }
{ The Original Code is DSpatial.inc. The Original Code is available through    }
{ the home page of DSpatial at http://dspatial.sourceforge.net.                }
{                                                                              }
{ The Initial Developer of the Original Code is Patrick Van Laake              }
{ (pvanlaake@users.sourceforge.net). Portions created by the Initial Developer }
{ are Copyright (C) of the Initial Developer. Changes to the Original Code     }
{ available through DSpatial are Copyright (C) of the Contributing Authors.    }
{                                                                              }
{******************************************************************************}
{                                                                              }
{ This include file defines the global directives for use with DSpatial. It    }
{ should be included in every file that is built using DSpatial.               }
{                                                                              }
{ Unit owner    : Patrick Van Laake                                            }
{ Last modified : 2003 November 28                                             }
{                                                                              }
{ Dependencies  : none                                                         }
{                                                                              }
{ Version       : 0.3  03Nov28 Detection of compiler version added.            }
{                 0.2  03Jul21 Added BUILD_SSE compiler directive.             }
{                 0.1  03May26 Initial coding.                                 }
{                                                                              }
{******************************************************************************}

{$ASSERTIONS ON}          // use this for debugging only
{$DEFINE BUILD_SSE}       // enable/disable the use of SSE extensions

// Logging
// Enable any of the below log levels (remove the dot) to add logging of events
// to your app. These log events are saved to file (see the DSpatial object in
// DSpGlobals) and can be displayed to the user. Anything higher than LOGLEVEL2
// is probably only useful for debugging and profiling. LOGLEVEL6 will produce
// prodigious amounts of logs. Note that you have to enable each log level
// individually. So LOGLEVEL3 does not enable LOGLEVEL1 and LOGLEVEL2.
//
// Logging is currently only partially supported.
{$DEFINE LOGLEVEL1}       // Creation/Deletion of data sets, source operations
{.$DEFINE LOGLEVEL2}       // Thread notifications, analysis operations
{.$DEFINE LOGLEVEL3}       // Sub-feature (e.g. raster band) notifications: create/delete/modify
{.$DEFINE LOGLEVEL4}       // Thread messages, kernel events
{.$DEFINE LOGLEVEL5}       // Resource usage, system events
{.$DEFINE LOGLEVEL6}       // Object method calls, will suffocate your app

// Establishing the compiler version
{$DEFINE OLDVER}

{$IFDEF VER150}
  {$DEFINE DELPHI7}
  {$UNDEF OLDVER}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE DELPHI6}
  {$UNDEF OLDVER}
{$ENDIF}

{$IFDEF VER130}
  {$DEFINE DELPHI5}
  {$UNDEF OLDVER}
{$ENDIF}

{$IFDEF OLDVER}
DSpatial will only compile successfully with Delphi 5 and up. You may be able to
patch the code to work with older versions of Delphi, but this is not supported.
{$ENDIF}

