{*******************************************************}
{                     PHP4Delphi                        }
{               ZEND - Delphi interface                 }
{                                                       }
{ Author:                                               }
{ Serhiy Perevoznyk                                     }
{ serge_perevoznyk@hotmail.com                          }
{ http://users.chello.be/ws36637                        }
{*******************************************************}
{$I PHP.INC}

{ $Id: ZENDAPI.pas,v 5.6 2003/12/10 11:49:02 delphi32 Exp $ } 

unit zendAPI;

interface

uses
  Windows, SysUtils;

type
  EPHP4DelphiException = class(Exception)
   constructor Create(const Msg: string);
  end;

procedure LoadZEND(const DllFilename: string = 'php4ts.dll');
procedure UnloadZEND;
function  ZENDLoaded: boolean;

type
  zend_uint   = uint;
  zend_bool   = boolean;
  zend_uchar  = char;
  zend_ulong  = ulong;
  zend_ushort = word;
  unsigned_char = byte;

  //zend_compile.h
const
  ZEND_NOP                                        = 0;
  ZEND_ADD                                        = 1;
  ZEND_SUB                                        = 2;
  ZEND_MUL                                        = 3;
  ZEND_DIV                                        = 4;
  ZEND_MOD                                        = 5;
  ZEND_SL                                         = 6;
  ZEND_SR                                         = 7;
  ZEND_CONCAT                                     = 8;
  ZEND_BW_OR                                      = 9;
  ZEND_BW_AND                                     = 10;
  ZEND_BW_XOR                                     = 11;
  ZEND_BW_NOT                                     = 12;
  ZEND_BOOL_NOT                                   = 13;
  ZEND_BOOL_XOR                                   = 14;
  ZEND_IS_IDENTICAL                               = 15;
  ZEND_IS_NOT_IDENTICAL                           = 16;
  ZEND_IS_EQUAL                                   = 17;
  ZEND_IS_NOT_EQUAL                               = 18;
  ZEND_IS_SMALLER                                 = 19;
  ZEND_IS_SMALLER_OR_EQUAL                        = 20;
  ZEND_CAST                                       = 21;
  ZEND_QM_ASSIGN                                  = 22;
  ZEND_ASSIGN_ADD                                 = 23;
  ZEND_ASSIGN_SUB                                 = 24;
  ZEND_ASSIGN_MUL                                 = 25;
  ZEND_ASSIGN_DIV                                 = 26;
  ZEND_ASSIGN_MOD                                 = 27;
  ZEND_ASSIGN_SL                                  = 28;
  ZEND_ASSIGN_SR                                  = 29;
  ZEND_ASSIGN_CONCAT                              = 30;
  ZEND_ASSIGN_BW_OR                               = 31;
  ZEND_ASSIGN_BW_AND                              = 32;
  ZEND_ASSIGN_BW_XOR                              = 33;
  ZEND_PRE_INC                                    = 34;
  ZEND_PRE_DEC                                    = 35;
  ZEND_POST_INC                                   = 36;
  ZEND_POST_DEC                                   = 37;
  ZEND_ASSIGN                                     = 38;
  ZEND_ASSIGN_REF                                 = 39;
  ZEND_ECHO                                       = 40;
  ZEND_PRINT                                      = 41;
  ZEND_JMP                                        = 42;
  ZEND_JMPZ                                       = 43;
  ZEND_JMPNZ                                      = 44;
  ZEND_JMPZNZ                                     = 45;
  ZEND_JMPZ_EX                                    = 46;
  ZEND_JMPNZ_EX                                   = 47;
  ZEND_CASE                                       = 48;
  ZEND_SWITCH_FREE                                = 49;
  ZEND_BRK                                        = 50;
  ZEND_CONT                                       = 51;
  ZEND_BOOLEAN                                    = 52; //original ZEND_BOOL
  ZEND_INIT_STRING                                = 53;
  ZEND_ADD_CHAR                                   = 54;
  ZEND_ADD_STRING                                 = 55;
  ZEND_ADD_VAR                                    = 56;
  ZEND_BEGIN_SILENCE                              = 57;
  ZEND_END_SILENCE                                = 58;
  ZEND_INIT_FCALL_BY_NAME                         = 59;
  ZEND_DO_FCALL                                   = 60;
  ZEND_DO_FCALL_BY_NAME                           = 61;
  ZEND_RETURN                                     = 62;
  ZEND_RECV                                       = 63;
  ZEND_RECV_INIT                                  = 64;
  ZEND_SEND_VAL                                   = 65;
  ZEND_SEND_VAR                                   = 66;
  ZEND_SEND_REF                                   = 67;
  ZEND_NEW                                        = 68;
  ZEND_JMP_NO_CTOR                                = 69;
  ZEND_FREE                                       = 70;
  ZEND_INIT_ARRAY                                 = 71;
  ZEND_ADD_ARRAY_ELEMENT                          = 72;
  ZEND_INCLUDE_OR_EVAL                            = 73;
  ZEND_UNSET_VAR                                  = 74;
  ZEND_UNSET_DIM_OBJ                              = 75;
  ZEND_ISSET_ISEMPTY                              = 76;
  ZEND_FE_RESET                                   = 77;
  ZEND_FE_FETCH                                   = 78;
  ZEND_EXIT                                       = 79;

  { the following 18 opcodes are 6 groups of 3 opcodes each, and must
   * remain in that order!
   }

const
  ZEND_FETCH_R                                    = 80;
  ZEND_FETCH_DIM_R                                = 81;
  ZEND_FETCH_OBJ_R                                = 82;
  ZEND_FETCH_W                                    = 83;
  ZEND_FETCH_DIM_W                                = 84;
  ZEND_FETCH_OBJ_W                                = 85;
  ZEND_FETCH_RW                                   = 86;
  ZEND_FETCH_DIM_RW                               = 87;
  ZEND_FETCH_OBJ_RW                               = 88;
  ZEND_FETCH_IS                                   = 89;
  ZEND_FETCH_DIM_IS                               = 90;
  ZEND_FETCH_OBJ_IS                               = 91;
  ZEND_FETCH_FUNC_ARG                             = 92;
  ZEND_FETCH_DIM_FUNC_ARG                         = 93;
  ZEND_FETCH_OBJ_FUNC_ARG                         = 94;
  ZEND_FETCH_UNSET                                = 95;
  ZEND_FETCH_DIM_UNSET                            = 96;
  ZEND_FETCH_OBJ_UNSET                            = 97;
  ZEND_FETCH_DIM_TMP_VAR                          = 98;
  ZEND_FETCH_CONSTANT                             = 99;
  ZEND_DECLARE_FUNCTION_OR_CLASS                  = 100;
  ZEND_EXT_STMT                                   = 101;
  ZEND_EXT_FCALL_BEGIN                            = 102;
  ZEND_EXT_FCALL_END                              = 103;
  ZEND_EXT_NOP                                    = 104;
  ZEND_TICKS                                      = 105;
  ZEND_SEND_VAR_NO_REF                            = 106;

  { end of block }

  { global/local fetches }

const
  ZEND_FETCH_GLOBAL                               = 0;
  ZEND_FETCH_LOCAL                                = 1;
  ZEND_FETCH_STATIC                               = 2;

  { var status for backpatching }

const
  BP_VAR_R                                        = 0;
  BP_VAR_W                                        = 1;
  BP_VAR_RW                                       = 2;
  BP_VAR_IS                                       = 3;
  BP_VAR_NA                                       = 4       { if not applicable }
  ;
  BP_VAR_FUNC_ARG                                 = 5;
  BP_VAR_UNSET                                    = 6;
  ZEND_INTERNAL_FUNCTION                          = 1;
  ZEND_USER_FUNCTION                              = 2;
  ZEND_OVERLOADED_FUNCTION                        = 3;
  ZEND_EVAL_CODE                                  = 4;
  ZEND_INTERNAL_CLASS                             = 1;
  ZEND_USER_CLASS                                 = 2;
  ZEND_EVAL                                       = (1 shl 0);
  ZEND_INCLUDE                                    = (1 shl 1);
  ZEND_INCLUDE_ONCE                               = (1 shl 2);
  ZEND_REQUIRE                                    = (1 shl 3);
  ZEND_REQUIRE_ONCE                               = (1 shl 4);
  ZEND_ISSET                                      = (1 shl 0);
  ZEND_ISEMPTY                                    = (1 shl 1);
  ZEND_CT                                         = (1 shl 0);
  ZEND_RT                                         = (1 shl 1);
  ZEND_HANDLE_FILENAME                            = 0;
  ZEND_HANDLE_FD                                  = 1;
  ZEND_HANDLE_FP                                  = 2;
  ZEND_HANDLE_STDIOSTREAM                         = 3;
  ZEND_HANDLE_FSTREAM                             = 4;
  ZEND_DECLARE_CLASS                              = 1;
  ZEND_DECLARE_FUNCTION                           = 2;
  ZEND_DECLARE_INHERITED_CLASS                    = 3;
  ZEND_FETCH_STANDARD                             = 0;
  ZEND_FETCH_ADD_LOCK                             = 1;
  ZEND_MEMBER_FUNC_CALL                           = 1 shl 0;
  ZEND_CTOR_CALL                                  = 1 shl 1;
  ZEND_ARG_SEND_BY_REF                            = (1 shl 0);
  ZEND_ARG_COMPILE_TIME_BOUND                     = (1 shl 1);
  ZEND_RETURN_VAL                                 = 0;
  ZEND_RETURN_REF                                 = 1;

  //zend_errors.h
const
  E_ERROR                                         = (1 shl 0);
  E_WARNING                                       = (1 shl 1);
  E_PARSE                                         = (1 shl 2);
  E_NOTICE                                        = (1 shl 3);
  E_CORE_ERROR                                    = (1 shl 4);
  E_CORE_WARNING                                  = (1 shl 5);
  E_COMPILE_ERROR                                 = (1 shl 6);
  E_COMPILE_WARNING                               = (1 shl 7);
  E_USER_ERROR                                    = (1 shl 8);
  E_USER_WARNING                                  = (1 shl 9);
  E_USER_NOTICE                                   = (1 shl 10);
  E_ALL                                           = (E_ERROR or E_WARNING or E_PARSE or E_NOTICE or E_CORE_ERROR or E_CORE_WARNING or E_COMPILE_ERROR or E_COMPILE_WARNING or E_USER_ERROR or E_USER_WARNING or E_USER_NOTICE);
  E_CORE                                          = (E_CORE_ERROR or E_CORE_WARNING);

  //zend.h
  //data types
const
  IS_NULL                                         = 0;
  IS_LONG                                         = 1;
  IS_DOUBLE                                       = 2;
  IS_STRING                                       = 3;
  IS_ARRAY                                        = 4;
  IS_OBJECT                                       = 5;
  IS_BOOL                                         = 6;
  IS_RESOURCE                                     = 7;
  IS_CONSTANT                                     = 8;
  IS_CONSTANT_ARRAY                               = 9;

  ZEND_PATHS_SEPARATOR                            = ';';
  SUCCESS                                         = 0;
  FAILURE                                         = -1;     { this MUST stay a negative number, or it may affect functions! }

  //zend_modules.h
const
  ZEND_MODULE_API_NO                              = 20020429;

{$IFDEF ZTS}
const
  USING_ZTS                                       = 1;
{$ELSE}
const
  USING_ZTS                                       = 0;
{$ENDIF}

const
  NO_VERSION_YET                                  = nil;
  MODULE_PERSISTENT                               = 1;
  MODULE_TEMPORARY                                = 2;

  //zend_alloc.h
const
  MEM_BLOCK_START_MAGIC                           = $7312F8DC;
  MEM_BLOCK_END_MAGIC                             = $2A8FCC84;
  MEM_BLOCK_FREED_MAGIC                           = $99954317;
  MEM_BLOCK_CACHED_MAGIC                          = $FB8277DC;

type
  size_t = cardinal;
  ppointer = ^pointer;
  pppointer = ^ppointer;

  PStat = ^TStat;
  TStat = record
    st_dev: Word;
    st_ino: Word;
    st_mode: Word;
    st_nlink: SmallInt;
    st_uid: SmallInt;
    st_gid: SmallInt;
    st_rdev: Word;
    st_size: Longint;
    st_atime: Longint;
    st_mtime: Longint;
    st_ctime: Longint;
  end;
  Stat = TStat;

  Pzend_mem_header = ^Tzend_mem_header;
  _zend_mem_header = record
    pNext: Pzend_mem_header;
    pLast: Pzend_mem_header;
    size_cached: integer;
  end;
  Tzend_mem_header = _zend_mem_header;

  align_test = record
    case Integer of
      1: (ptr: Pointer; );
      2: (dbl: Double; );
      3: (lng: Longint; );
  end;

const
  MAX_CACHED_MEMORY                               = 11;
  MAX_CACHED_ENTRIES                              = 256;
  PRE_INIT_CACHE_ENTRIES                          = 32;

const
  PLATFORM_ALIGNMENT                              = (SizeOf(align_test));

var
  zend_strndup                                    : function(s: PChar; length: Integer): PChar; cdecl;
  _emalloc                                        : function(size: size_t; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint): pointer; cdecl;
  _efree                                          : procedure(ptr: pointer; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint); cdecl;
  _ecalloc                                        : function(nmemb: size_t; size: size_t; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint): pointer; cdecl;
  _erealloc                                       : function(ptr: pointer; size: size_t; allow_failure: integer; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint): pointer; cdecl;
  _estrdup                                        : function(const s: PChar; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint): pointer; cdecl;
  _estrndup                                       : function(s: PChar; Len: Cardinal; __zend_filename: PChar; __zend_lineno: uint; __zend_orig_filename: PChar; __zend_orig_line_no: uint): PChar; cdecl;

function emalloc(size: size_t): pointer;
procedure efree(ptr: pointer);
function ecalloc(nmemb: size_t; size: size_t): pointer;
function erealloc(ptr: pointer; size: size_t; allow_failure: integer): pointer;
function estrdup(const s: PChar): PChar;
function estrndup(s: PChar; len: Cardinal): PChar;

var
  zend_set_memory_limit                           : function(memory_limit: uint): integer; cdecl;
  start_memory_manager                            : procedure(TSRMLS_D: pointer); cdecl;
  shutdown_memory_manager                         : procedure(silent: integer; clean_cache: integer; TSRMLS_DC: pointer); cdecl;

  //zend_hash.h
const
  HASH_KEY_IS_STRING                              = 1;
  HASH_KEY_IS_LONG                                = 2;
  HASH_KEY_NON_EXISTANT                           = 3;
  HASH_UPDATE                                     = (1 shl 0);
  HASH_ADD                                        = (1 shl 1);
  HASH_NEXT_INSERT                                = (1 shl 2);
  HASH_DEL_KEY                                    = 0;
  HASH_DEL_INDEX                                  = 1;

type

  hash_func_t = function(arKey: PChar; nKeyLength: uint): ulong;

  compare_func_t = function(_noname1: Pointer; _noname2: Pointer;
    TSRMLS_DC: Pointer): integer;

  dtor_func_t = procedure(pDest: Pointer);

  copy_ctor_func_t = procedure(pElement: Pointer);

  PBucket = ^TBucket;
  TBucket =
    record
    h: ulong;
    nKeyLength: uint;
    pData: Pointer;
    pDataPtr: Pointer;
    pListNext: PBucket;
    pListLast: PBucket;
    pNext: PBucket;
    pLast: PBucket;
    arKey: array[0..0] of char;
  end;

  PHashTable = ^THashTable;
  THashTable =
    record
    nTableSize: uint;
    nTableMask: uint;
    nNumOfElements: uint;
    nNextFreeElement: ulong;
    pInternalPointer: PBucket;
    pListHead: PBucket;
    pListTail: PBucket;
    arBuckets: ^PBucket;
    pDestructor: pointer;
    persistent: boolean;
    nApplyCount: Byte;
    bApplyProtection: boolean;
  end;

  HashPosition = PBucket;

  Pzend_class_entry = ^Tzend_class_entry;
  Tzend_class_entry =
    record
    _type: Char;
    name: PChar;
    name_length: uint;
    parent: pointer;
    refcount: pointer;
    constants_updated: boolean;
    function_table: THashTable;
    default_properties: THashTable;
    builtin_functions: pointer;
    handle_function_call: pointer;
    handle_property_get: pointer;
    handle_property_set: pointer;
  end;

  _zend_object = record
    ce: Pzend_class_entry;
    properties: PHashTable;
  end;

  Tzend_Object = _zend_object;
  Pzend_Object = ^Tzend_object;

  Pzvalue_value = ^zvalue_value;
  zvalue_value = record
    case longint of
      0: (lval: longint);
      1: (dval: double);
      2: (str: record
          val: PChar;
          len: longint;
        end);
      3: (ht: PHashTable);
      4: (obj: Tzend_Object);
  end;

  pppzval = ^ppzval;
  ppzval = ^pzval;
  Pzval = ^zval;
  zval = record
    value: zvalue_value;
    _type: Byte;
    is_ref: Byte;
    refcount: Smallint;
  end;

  ppzval_array = ^pzval_array;
  pzval_array = array of ppzval;

  { startup/shutdown }

var
  zend_hash_init                                  : function(ht: PHashTable; nSize: uint;
    pHashFunction: pointer; pDestructor: pointer;
    persistent: Integer): Integer; cdecl;

  zend_hash_init_ex                               : function(ht: PHashTable; nSize: uint;
    pHashFunction: pointer; pDestructor: pointer;
    persistent: Integer; bApplyProtection: boolean): Integer; cdecl;

  zend_hash_destroy                               : procedure(ht: PHashTable); cdecl;
  zend_hash_clean                                 : procedure(ht: PHashTable); cdecl;

  { additions/updates/changes }

  zend_hash_add_or_update                         : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint; pData: Pointer; nDataSize: uint; pDest: Pointer;
    flag: Integer): Integer; cdecl;

  zend_hash_quick_add_or_update                   : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint; h: ulong; pData: Pointer; nDataSize: uint;
    pDest: Pointer; flag: Integer): Integer; cdecl;

  zend_hash_index_update_or_next_insert           : function(ht: PHashTable; h: ulong;
    pData: Pointer; nDataSize: uint; pDest: Pointer; flag: Integer): Integer; cdecl;

  zend_hash_add_empty_element                     : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint): Integer; cdecl;

const
  ZEND_HASH_APPLY_KEEP                            = 0;
  ZEND_HASH_APPLY_REMOVE                          = 1 shl 0;
  ZEND_HASH_APPLY_STOP                            = 1 shl 1;

type
  zend_hash_key = record
    arKey: PChar;
    nKeyLength: uint;
    h: ulong;
  end;

  zend_hash_graceful_reverse_destroy_t = procedure(ht: PHashTable); cdecl;

var
  zend_hash_graceful_destroy                      : procedure(ht: PHashTable); cdecl;
  zend_hash_graceful_reverse_destroy              : zend_hash_graceful_reverse_destroy_t;

  zend_hash_apply                                 : procedure(ht: PHashTable; apply_func: pointer; TSRMLS_DC: Pointer); cdecl;

  zend_hash_apply_with_argument                   : procedure(ht: PHashTable;
    apply_func: pointer; _noname1: Pointer; TSRMLS_DC: Pointer); cdecl;

  { This function should be used with special care (in other words,
   * it should usually not be used).  When used with the ZEND_HASH_APPLY_STOP
   * return value, it assumes things about the order of the elements in the hash.
   * Also, it does not provide the same kind of reentrancy protection that
   * the standard apply functions do.
   }

  zend_hash_reverse_apply                         : procedure(ht: PHashTable;
    apply_func: pointer; TSRMLS_DC: Pointer); cdecl;

  { Deletes }

  zend_hash_del_key_or_index                      : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint; h: ulong; flag: Integer): Integer; cdecl;

  zend_get_hash_value                             : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint): Longint; cdecl;

  { Data retreival }

  zend_hash_find                                  : function(ht: PHashTable; arKey: PChar; nKeyLength: uint;
    pData: Pointer): Integer; cdecl;

  zend_hash_quick_find                            : function(ht: PHashTable; arKey: PChar;
    nKeyLength: uint; h: ulong; pData: Pointer): Integer; cdecl;

  zend_hash_index_find                            : function(ht: PHashTable; h: ulong; pData: Pointer): Integer; cdecl;

  { Misc }

  zend_hash_exists                                : function(ht: PHashTable; arKey: PChar; nKeyLength: uint): Integer; cdecl;

  zend_hash_index_exists                          : function(ht: PHashTable; h: ulong): Integer; cdecl;

  zend_hash_next_free_element                     : function(ht: PHashTable): Longint; cdecl;

  { traversing }

  zend_hash_move_forward_ex                       : function(ht: PHashTable; pos: HashPosition): Integer; cdecl;

  zend_hash_move_backwards_ex                     : function(ht: PHashTable; pos: HashPosition): Integer; cdecl;

  zend_hash_get_current_key_ex                    : function(ht: PHashTable;
    var str_index: PChar; var str_length: uint; var num_index: ulong;
    duplicate: boolean; pos: HashPosition): Integer; cdecl;

  zend_hash_get_current_key_type_ex               : function(ht: PHashTable; pos: HashPosition): Integer; cdecl;

  zend_hash_get_current_data_ex                   : function(ht: PHashTable; pData: Pointer; pos: HashPosition): Integer; cdecl;

  zend_hash_internal_pointer_reset_ex             : procedure(ht: PHashTable; pos: HashPosition); cdecl;

  zend_hash_internal_pointer_end_ex               : procedure(ht: PHashTable; pos: HashPosition); cdecl;

  { Copying, merging and sorting }

  zend_hash_copy                                  : procedure(target: PHashTable; source: PHashTable;
    pCopyConstructor: pointer; tmp: Pointer; size: uint); cdecl;

  zend_hash_merge                                 : procedure(target: PHashTable; source: PHashTable;
    pCopyConstructor: pointer; tmp: Pointer; size: uint; overwrite: Integer); cdecl;

  zend_hash_sort                                  : function(ht: PHashTable; sort_func: pointer;
    compare_func: pointer; renumber: Integer; TSRMLS_DC: Pointer): Integer; cdecl;

  zend_hash_compare                               : function(ht1: PHashTable; ht2: PHashTable;
    compar: pointer; ordered: boolean; TSRMLS_DC: Pointer): Integer; cdecl;

  zend_hash_minmax                                : function(ht: PHashTable; compar: pointer;
    flag: Integer; pData: Pointer; TSRMLS_DC: Pointer): Integer; cdecl;

  zend_hash_num_elements                          : function(ht: PHashTable): Integer; cdecl;

  zend_hash_rehash                                : function(ht: PHashTable): Integer; cdecl;

  zend_hash_func                                  : function(arKey: PChar; nKeyLength: uint): Longint; cdecl;


function zend_hash_get_current_data(ht: PHashTable; pData: Pointer): Integer; cdecl;
procedure zend_hash_internal_pointer_reset(ht: PHashTable); cdecl;

  //zend_constants.h
const
  CONST_CS                                        = (1 shl 0) { Case Sensitive }
  ;
  CONST_PERSISTENT                                = (1 shl 1) { Persistent }
  ;

type
  zend_constant =
    record
    value: zval;
    flags: Integer;
    name: PChar;
    name_len: uint;
    module_number: Integer;
  end;

var
  zend_get_constant                               : function(name: PChar; name_len: uint; var result: zval;
    TSRMLS_DC: Pointer): Integer; cdecl;

  zend_register_long_constant                     : procedure(name: PChar; name_len: uint;
    lval: Longint; flags: Integer; module_number: Integer; TSRMLS_DC: Pointer); cdecl;

  zend_register_double_constant                   : procedure(name: PChar; name_len: uint; dval: Double; flags: Integer; module_number: Integer;
    TSRMLS_DC: Pointer); cdecl;

  zend_register_string_constant                   : procedure(name: PChar; name_len: uint; strval: PChar; flags: Integer; module_number: Integer;
    TSRMLS_DC: Pointer); cdecl;

  zend_register_stringl_constant                  : procedure(name: PChar; name_len: uint;
    strval: PChar; strlen: uint; flags: Integer; module_number: Integer;
    TSRMLS_DC: Pointer); cdecl;

  zend_register_constant                          : function(var c: zend_constant; TSRMLS_DC: Pointer): Integer; cdecl;

procedure REGISTER_MAIN_LONG_CONSTANT(name: PChar; lval: longint; flags: integer; TSRMLS_DC: Pointer);
procedure REGISTER_MAIN_DOUBLE_CONSTANT(name: PChar; dval: double; flags: integer; TSRMLS_DC: Pointer);
procedure REGISTER_MAIN_STRING_CONSTANT(name: PChar; str: PChar; flags: integer; TSRMLS_DC: Pointer);
procedure REGISTER_MAIN_STRINGL_CONSTANT(name: PChar; str: PChar; len: uint; flags: integer; TSRMLS_DC: Pointer);

type
  zend_file_handle =
    record
    _type: uchar;
    filename: PChar;
    opened_path: PChar;
    handle:
    record
      case Integer of
        1:
        (
          fd: Integer;
          );
        2:
        (
          fp: pointer;
          );
    end;
    free_filename: short;
  end;

  //TSRM.h

  // Debug support
const
  TSRM_ERROR_LEVEL_ERROR                          = 1;
  TSRM_ERROR_LEVEL_CORE                           = 2;
  TSRM_ERROR_LEVEL_INFO                           = 3;

type
  ts_rsrc_id = integer;
  pts_rsrc_id = ^ts_rsrc_id;

var
  tsrm_startup                                    : function(expected_threads: integer;
    expected_resources: integer; debug_level: integer; debug_filename: pchar): integer; cdecl;

  ts_allocate_id                                  : function(rsrc_id: pts_rsrc_id; size: size_t; ctor: pointer; dtor: pointer): ts_rsrc_id; cdecl;
  // deallocates all occurrences of a given id
  ts_free_id                                      : procedure(id: ts_rsrc_id); cdecl;

  tsrm_shutdown                                   : procedure(void: pointer); cdecl;
  ts_resource_ex                                  : function(id: integer; p: pointer): pointer; cdecl;
  ts_free_thread                                  : procedure; cdecl;

  zend_error                                      : procedure(ErrType: integer; ErrText: PChar); cdecl;
  zend_error_cb                                   : procedure; cdecl;

  zend_eval_string                                : function(str: pchar; val: pointer; strname: pchar; tsrm: pointer): integer; cdecl;
  zend_make_compiled_string_description           : function(a: Pchar; tsrm: pointer): PChar; cdecl;
  _zval_dtor                                      : procedure(val: pzval; __zend_filename: PChar; __zend_lineno: uint); cdecl;
  _zval_copy_ctor                                 : function(val: pzval; __zend_filename: PChar; __zend_lineno: uint): integer; cdecl;
  zend_print_variable                             : function(val: pzval): integer; cdecl;


function ts_resource(id : integer) : pointer;

procedure zenderror(Error : PChar);


  //zend_stack.h
type
  pzend_stack = ^Tzend_stack;
  zend_stack =
    record
    top: Integer;
    max: Integer;
    elements: PPointer;
  end;
  Tzend_stack = zend_stack;

const
  STACK_BLOCK_SIZE                                = 64;

var
  zend_stack_init                                 : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_push                                 : function(stack: Pzend_stack; element: Pointer; size: Integer): Integer; cdecl;

  zend_stack_top                                  : function(stack: Pzend_stack; element: Pointer): Integer; cdecl;

  zend_stack_del_top                              : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_int_top                              : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_is_empty                             : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_destroy                              : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_base                                 : function(stack: Pzend_stack): Pointer; cdecl;

  zend_stack_count                                : function(stack: Pzend_stack): Integer; cdecl;

  zend_stack_apply                                : procedure(stack: Pzend_stack; _type: Integer; apply_function: Integer); cdecl;

  zend_stack_apply_with_argument                  : procedure(stack: Pzend_stack; _type: Integer; apply_function: Integer; arg: Pointer); cdecl;

const
  ZEND_STACK_APPLY_TOPDOWN                        = 1;
  ZEND_STACK_APPLY_BOTTOMUP                       = 2;

  //zend_operators.h

var
  _convert_to_string                              : procedure(op: pzval; __zend_filename: PChar; __zend_lineno: uint); cdecl;

procedure convert_to_string(op: pzval);

var
  add_function                                    : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  sub_function                                    : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  mul_function                                    : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  div_function                                    : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  mod_function                                    : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  boolean_xor_function                            : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  boolean_not_function                            : function(_result: Pzval; op1: Pzval): Integer; cdecl;

  bitwise_not_function                            : function(_result: Pzval; op1: Pzval): Integer; cdecl;

  bitwise_or_function                             : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  bitwise_and_function                            : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  bitwise_xor_function                            : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  shift_left_function                             : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  shift_right_function                            : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  concat_function                                 : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_equal_function                               : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_identical_function                           : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_not_identical_function                       : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_not_equal_function                           : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_smaller_function                             : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  is_smaller_or_equal_function                    : function(_result: Pzval; op1: Pzval; var op2: zval; TSRMLS_DC: Pointer): Integer; cdecl;

  increment_function                              : function(op1: Pzval): Integer; cdecl;

  decrement_function                              : function(op2: Pzval): Integer; cdecl;

  convert_scalar_to_number                        : procedure(op: Pzval; TSRMLS_DC: Pointer); cdecl;

  convert_to_long                                 : procedure(op: Pzval); cdecl;

  convert_to_double                               : procedure(op: Pzval); cdecl;

  convert_to_long_base                            : procedure(op: Pzval; base: Integer); cdecl;

  convert_to_null                                 : procedure(op: Pzval); cdecl;

  convert_to_boolean                              : procedure(op: Pzval); cdecl;

  convert_to_array                                : procedure(op: Pzval); cdecl;

  convert_to_object                               : procedure(op: Pzval); cdecl;

  add_char_to_string                              : function(_result: Pzval; op1: Pzval; op2: Pzval): Integer; cdecl;

  add_string_to_string                            : function(_result: Pzval; op1: Pzval; op2: Pzval): Integer; cdecl;

  zend_string_to_double                           : function(number: PChar; length: zend_uint): Double; cdecl;

  zval_is_true                                    : function(op: Pzval): Integer; cdecl;

  compare_function                                : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  numeric_compare_function                        : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  string_compare_function                         : function(_result: Pzval; op1: Pzval; op2: Pzval; TSRMLS_DC: Pointer): Integer; cdecl;

  zend_str_tolower                                : procedure(str: PChar; length: Integer); cdecl;

  zend_binary_zval_strcmp                         : function(s1: Pzval; s2: Pzval): Integer; cdecl;

  zend_binary_zval_strncmp                        : function(s1: Pzval; s2: Pzval; s3: Pzval): Integer; cdecl;

  zend_binary_zval_strcasecmp                     : function(s1: Pzval; s2: Pzval): Integer; cdecl;

  zend_binary_zval_strncasecmp                    : function(s1: Pzval; s2: Pzval; s3: Pzval): Integer; cdecl;

  zend_binary_strcmp                              : function(s1: PChar; len1: uint; s2: PChar; len2: uint): Integer; cdecl;

  zend_binary_strncmp                             : function(s1: PChar; len1: uint; s2: PChar; len2: uint; length: uint): Integer; cdecl;

  zend_binary_strcasecmp                          : function(s1: PChar; len1: uint; s2: PChar; len2: uint): Integer; cdecl;

  zend_binary_strncasecmp                         : function(s1: PChar; len1: uint; s2: PChar; len2: uint; length: uint): Integer; cdecl;

  zendi_smart_strcmp                              : procedure(_result: zval; s1: Pzval; s2: Pzval); cdecl;

  zend_compare_symbol_tables                      : procedure(_result: Pzval; ht1: PHashTable; ht2: PHashTable; TSRMLS_DC: Pointer); cdecl;

  zend_compare_arrays                             : procedure(_result: zval; a1: Pzval; a2: Pzval; TSRMLS_DC: Pointer); cdecl;

  zend_compare_objects                            : procedure(_result: Pzval; o1: Pzval; o2: Pzval; TSRMLS_DC: Pointer); cdecl;

  zend_atoi                                       : function(str: PChar; str_len: Integer): Integer; cdecl;

  //zend_execute.h
  get_active_function_name                        : function(TSRMLS_D: pointer): PChar; cdecl;

  zend_get_executed_filename                      : function(TSRMLS_D: pointer): PChar; cdecl;

  zend_set_timeout                                : procedure(seconds: Longint); cdecl;

  zend_unset_timeout                              : procedure(TSRMLS_D: pointer); cdecl;

  zend_timeout                                    : procedure(dummy: Integer); cdecl;

  //zend_highlight.h
const
  HL_COMMENT_COLOR                                = '#FF8000' { orange }
  ;
  HL_DEFAULT_COLOR                                = '#0000BB' { blue }
  ;
  HL_HTML_COLOR                                   = '#000000' { black }
  ;
  HL_STRING_COLOR                                 = '#DD0000' { red }
  ;
  HL_BG_COLOR                                     = '#FFFFFF' { white }
  ;
  HL_KEYWORD_COLOR                                = '#007700' { green }
  ;

type
  Pzend_syntax_highlighter_ini = ^Tzend_syntax_highlighter_ini;
  zend_syntax_highlighter_ini =
    record
    highlight_html: PChar;
    highlight_comment: PChar;
    highlight_default: PChar;
    highlight_string: PChar;
    highlight_keyword: PChar;
  end;
  Tzend_syntax_highlighter_ini = zend_syntax_highlighter_ini;

var
  zend_highlight                                  : procedure(syntax_highlighter_ini: Pzend_syntax_highlighter_ini; TSRMLS_DC: Pointer); cdecl;

  zend_strip                                      : procedure(TSRMLS_D: pointer); cdecl;

  highlight_file                                  : function(filename: PChar; syntax_highlighter_ini: Pzend_syntax_highlighter_ini; TSRMLS_DC: Pointer): Integer; cdecl;

  highlight_string                                : function(str: Pzval; syntax_highlighter_ini: Pzend_syntax_highlighter_ini; str_name: PChar; TSRMLS_DC: Pointer): Integer; cdecl;

  zend_html_putc                                  : procedure(c: Char); cdecl;

  zend_html_puts                                  : procedure(s: PChar; len: uint; TSRMLS_DC: Pointer); cdecl;

  zend_indent                                     : procedure; cdecl;

  ZendGetParameters                               : function: integer; cdecl;

function zend_get_parameters_ex(number: integer; var Params: pzval_array): integer;

function zend_get_parameters(ht: integer; param_count: integer; Params: array of ppzval): integer;

var
  _zend_get_parameters_array_ex                   : function(param_count: integer; argument_array: pppointer; TSRMLS_CC: pointer): integer; cdecl;

procedure dispose_pzval_array(Params: pzval_array);

var
  zend_ini_refresh_caches                         : procedure(stage: Integer; TSRMLS_DC: Pointer); cdecl;

const
  ZEND_INI_USER                                   = (1 shl 0);
  ZEND_INI_PERDIR                                 = (1 shl 1);
  ZEND_INI_SYSTEM                                 = (1 shl 2);
  ZEND_INI_ALL                                    = (ZEND_INI_USER or ZEND_INI_PERDIR or ZEND_INI_SYSTEM);

  ZEND_INI_DISPLAY_ORIG                           = 1;
  ZEND_INI_DISPLAY_ACTIVE                         = 2;
  ZEND_INI_STAGE_STARTUP                          = (1 shl 0);
  ZEND_INI_STAGE_SHUTDOWN                         = (1 shl 1);
  ZEND_INI_STAGE_ACTIVATE                         = (1 shl 2);
  ZEND_INI_STAGE_DEACTIVATE                       = (1 shl 3);
  ZEND_INI_STAGE_RUNTIME                          = (1 shl 4);

var
  zend_alter_ini_entry                            : function(name: PChar; name_length: uint; new_value: PChar; new_value_length: uint; modify_type: Integer; stage: Integer): Integer; cdecl;

  zend_restore_ini_entry                          : function(name: PChar; name_length: uint; stage: Integer): Integer; cdecl;

  zend_ini_long                                   : function(name: PChar; name_length: uint; orig: Integer): Longint; cdecl;

  zend_ini_double                                 : function(name: PChar; name_length: uint; orig: Integer): Double; cdecl;

  zend_ini_string                                 : function(name: PChar; name_length: uint; orig: Integer): PChar; cdecl;

  compile_string                                  : function(source_string: pzval; filename: PChar; TSRMLS_DC: Pointer): pointer; cdecl;

  execute                                         : procedure(op_array: pointer; TSRMLS_DC: Pointer); cdecl;

  zend_wrong_param_count                          : procedure(TSRMLS_D: pointer); cdecl;

  add_property_long_ex                            : function(arg: pzval; key: PChar; key_len: uint; l: longint): integer; cdecl;
  add_property_null_ex                            : function(arg: pzval; key: PChar; key_len: uint): integer; cdecl;
  add_property_bool_ex                            : function(arg: pzval; key: PChar; key_len: uint; b: integer): integer; cdecl;
  add_property_resource_ex                        : function(arg: pzval; key: PChar; key_len: uint; r: integer): integer; cdecl;
  add_property_double_ex                          : function(arg: pzval; key: PChar; key_len: uint; d: double): integer; cdecl;
  add_property_string_ex                          : function(arg: pzval; key: PChar; key_len: uint; str: PChar; duplicate: integer): integer; cdecl;
  add_property_stringl_ex                         : function(arg: pzval; key: PChar; key_len: uint; str: PChar; len: uint; duplicate: integer): integer; cdecl;
  add_property_zval_ex                            : function(arg: pzval; key: PChar; key_len: uint; value: pzval): integer; cdecl;

  add_assoc_long_ex                               : function(arg: pzval; key: PChar; key_len: uint; n: longint): integer; cdecl;
  add_assoc_null_ex                               : function(arg: pzval; key: PChar; key_len: uint): integer; cdecl;
  add_assoc_bool_ex                               : function(arg: pzval; key: PChar; key_len: uint; b: integer): integer; cdecl;
  add_assoc_resource_ex                           : function(arg: pzval; key: PChar; key_len: uint; r: integer): integer; cdecl;
  add_assoc_double_ex                             : function(arg: pzval; key: PChar; key_len: uint; d: double): integer; cdecl;
  add_assoc_string_ex                             : function(arg: pzval; key: PChar; key_len: uint; str: PChar; duplicate: integer): integer; cdecl;
  add_assoc_stringl_ex                            : function(arg: pzval; key: PChar; key_len: uint; str: PChar; len: uint; duplicate: integer): integer; cdecl;
  add_assoc_zval_ex                               : function(arg: pzval; key: PChar; key_len: uint; value: pzval): integer; cdecl;

  add_index_long                                  : function(arg: pzval; idx: uint; n: longint): integer; cdecl;
  add_index_null                                  : function(arg: pzval; idx: uint): integer; cdecl;
  add_index_bool                                  : function(arg: pzval; idx: uint; b: integer): integer; cdecl;
  add_index_resource                              : function(arg: pzval; idx: uint; r: integer): integer; cdecl;
  add_index_double                                : function(arg: pzval; idx: uint; d: double): integer; cdecl;
  add_index_string                                : function(arg: pzval; idx: uint; str: PChar; duplicate: integer): integer; cdecl;
  add_index_stringl                               : function(arg: pzval; idx: uint; str: PChar; len: uint; duplicate: integer): integer; cdecl;
  add_index_zval                                  : function(arg: pzval; index: uint; value: pzval): integer; cdecl;

  add_next_index_long                             : function(arg: pzval; n: longint): integer; cdecl;
  add_next_index_null                             : function(arg: pzval): integer; cdecl;
  add_next_index_bool                             : function(arg: pzval; b: integer): integer; cdecl;
  add_next_index_resource                         : function(arg: pzval; r: integer): integer; cdecl;
  add_next_index_double                           : function(arg: pzval; d: double): integer; cdecl;
  add_next_index_string                           : function(arg: pzval; str: PChar; duplicate: integer): integer; cdecl;
  add_next_index_stringl                          : function(arg: pzval; str: PChar; len: uint; duplicate: integer): integer; cdecl;
  add_next_index_zval                             : function(arg: pzval; value: pzval): integer; cdecl;

  add_get_assoc_string_ex                         : function(arg: pzval; key: PChar; key_len: uint; str: PChar; dest: pointer; duplicate: integer): integer; cdecl;
  add_get_assoc_stringl_ex                        : function(arg: pzval; key: PChar; key_len: uint; str: PChar; len: uint; dest: pointer; duplicate: integer): integer; cdecl;

  add_get_index_long                              : function(arg: pzval; idx: uint; l: longint; dest: pointer): integer; cdecl;
  add_get_index_double                            : function(arg: pzval; idx: uint; d: double; dest: pointer): integer; cdecl;
  add_get_index_string                            : function(arg: pzval; idx: uint; str: PChar; dest: pointer; duplicate: integer): integer; cdecl;
  add_get_index_stringl                           : function(arg: pzval; idx: uint; str: PChar; len: uint; dest: pointer; duplicate: integer): integer; cdecl;

  _array_init                                     : function(arg: pzval; __zend_filename: pchar; __zend_lineno: uint): integer; cdecl;
  _object_init                                    : function(arg: pzval; __zend_filename: PChar; __zend_lineno: uint; TSRMLS_DC: pointer): integer; cdecl;
  _object_init_ex                                 : function(arg: pzval; ce: pointer; __zend_filename: pchar; __zend_lineno: uint; TSRMLS_DC: pointer): integer; cdecl;
  _object_and_properties_init                     : function(arg: pzval; ce: pointer; properties: phashtable; __zend_filename: pchar; __zend_lineno: uint; TSRMLS_DC: pointer): integer; cdecl;



type
  zend_write_t = function(str: PChar; str_length: integer): integer; cdecl;

var
  zend_write                                      : zend_write_t;

procedure ZEND_PUTS(str: PChar);

type

  Pzend_function_entry = ^Tzend_function_entry;
  zend_function_entry = record
    fname: Pchar;
    handler: pointer;
    func_arg_types: Pbyte;
  end;
  Tzend_function_entry = zend_function_entry;

  Pzend_module_entry = ^Tzend_module_entry;
  Tzend_module_entry = record
    size: word;
    zend_api: dword;
    zend_debug: byte;
    zts: byte;
    name: pchar;
    functions: pointer;
    module_startup_func: pointer;
    module_shutdown_func: pointer;
    request_startup_func: pointer;
    request_shutdown_func: pointer;
    info_func: pointer;
    version: pchar;
    global_startup_func: pointer;
    global_shutdown_func: pointer;
    global_id: integer;
    module_started: integer;
    _type: byte;
    handle: pointer;
    module_number: longint;
  end;

var
  zend_register_internal_class                    : function(class_entry: pzend_class_entry; TSRMLS_DC: pointer): Pzend_class_entry; cdecl;
  zend_register_internal_class_ex                 : function(class_entry: pzend_class_entry; parent_ce: pzend_class_entry; parent_name: Pchar; TSRMLS_DC: pointer): Pzend_class_entry; cdecl;

procedure ZVAL_RESOURCE(value: pzval; l: longint);
procedure ZVAL_BOOL(z: pzval; b: boolean);
procedure ZVAL_NULL(z: pzval);
procedure ZVAL_LONG(z: pzval; l: longint);
procedure ZVAL_DOUBLE(z: pzval; d: double);
procedure ZVAL_STRING(z: pzval; s: pchar; duplicate: boolean);
procedure ZVAL_STRINGL(z: pzval; s: pchar; l: integer; duplicate: boolean);
procedure ZVAL_EMPTY_STRING(z: pzval);
procedure ZVAL_TRUE(z: pzval);
procedure ZVAL_FALSE(z: pzval);

type
  pzend_list_element = ^zend_list_element;
  zend_list_element = record
    prev: pzend_list_element;
    next: pzend_list_element;
    data: char;
  end;

  pzend_llist = ^zend_llist;
  zend_llist = record
    head: pzend_list_element;
    tail: pzend_list_element;
    size: size_t;
    count: size_t;
    dtor: pointer;
    persistent: byte;
    traverse_ptr: pzend_list_element;
  end;

   pzend_overloaded_element = ^Zend_overloaded_element;
   zend_overloaded_element = record
    _type : integer;
    element : zval;
   end;

procedure INIT_CLASS_ENTRY(var class_container: Tzend_class_entry; class_name: pchar; functions: pointer);

type
  _zend_property_reference = record
    _type: integer;
    _object: pzval;
    elements_list: pzend_llist;
  end;

  Tzend_property_reference = _zend_property_reference;
  Pzend_property_reference = ^Tzend_property_reference;

var
  get_zend_version                                : function(): PChar; cdecl;
  zend_make_printable_zval                        : procedure(expr: pzval; expr_copy: pzval; use_copy: pint); cdecl;
  zend_print_zval                                 : function(expr: pzval; indent: integer): integer; cdecl;
  zend_print_zval_r                               : procedure(expr: pzval; indent: integer); cdecl;
  zend_output_debug_string                        : procedure(trigger_break: boolean; Msg: PChar); cdecl;

type
  //Zend internal function
  TInternalFunction = procedure(ht: integer; return_value: pzval; this_ptr: pzval;
    return_value_used: integer; TSRMLS_DC: pointer); cdecl;

  PInitFunction = ^TInitFunction;
  TInitFunction = function(_type: integer; module_number: integer; TSRMLS_DC: pointer): integer; cdecl;

  PShutdownFunction = ^TShutdownFunction;
  TShutdownFunction = function(_type: integer; module_number: integer; TSRMLS_DC: pointer): integer; cdecl;

  PZendModuleInfoFunction = ^TZendModuleInfoFunction;
  TZendModuleInfoFunction = procedure(zend_module: Pzend_module_entry; TSRMLS_DC: pointer); cdecl;

  //global startup and shutdown function
  TZendGlobalFunction = procedure(); cdecl;

  TZendModuleType = (mtPersistent, mtTemporary);

type

 _zend_declarables = record
	ticks : zval;
 end;
 zend_declarables = _zend_declarables;

 zend_compiler_globals  = record
    bp_stack : zend_stack;
    switch_cond_stack : zend_stack;
    foreach_copy_stack : zend_stack;
    object_stack : zend_stack;
    declare_stack : zend_stack;
    class_entry : Tzend_class_entry;
    active_class_entry : PZend_class_entry;
    active_ce_parent_class_name : zval;

    //variables for list() compilation
    list_llist : zend_llist;
    dimension_llist : zend_llist;
    list_stack : zend_stack;

    function_call_stack : zend_stack;

    compiled_filename : PChar;

    zend_lineno : integer;
    comment_start_line : integer;
    heredoc : PChar;
    heredoc_len : integer;

    active_op_array : pointer;

    function_table : PHashTable; // function symbol table
    class_table : PHashTable;    // class table

    filenames_table : THashTable;

    auto_globals : PHashTable;

    in_compilation : zend_bool;
    short_tags : zend_bool;
    asp_tags : zend_bool;
    allow_call_time_pass_reference : zend_bool;

    declarables : zend_declarables;

    // For extensions support
    extended_info : zend_bool;  // generate extension information for debugger/profiler
    handle_op_arrays : zend_bool; // run op_arrays through op_array handlers

    unclean_shutdown : zend_bool;

    ini_parser_unbuffered_errors : zend_bool;

    open_files : zend_llist;

    ini_parser_param : pointer;

    interactive : integer;

    increment_lineno : zend_bool;
  end;


  zend_ptr_stack  = record
   top, max : integer;
   elements : pointer;
   top_element : pointer;
  end;

  Pzend_executor_globals = ^zend_executor_globals; 
  zend_executor_globals  = record
    return_value_ptr_ptr : ppzval;

     uninitialized_zval : zval;
     uninitialized_zval_ptr : pzval;

     error_zval : zval;
     error_zval_ptr : pzval;

     function_state_ptr : pointer;
     arg_types_stack : zend_ptr_stack;

     // symbol table cache
     symtable_cache : array[0..31] of PHashTable;
     symtable_cache_limit : ^PHashTable;
     symtable_cache_ptr : ^PHashTable;

     opline_ptr : pointer;

     current_execute_data : pointer;

     active_symbol_table : PHashTable;
     symbol_table : THashTable;	// main symbol table

     included_files : THashTable;	// files already included */

     bailout : array[0..63] of byte;

     error_reporting : integer;
     orig_error_reporting : integer;
     exit_status : integer;

     active_op_array : pointer;

     function_table : PHashTable;	// function symbol table */
     class_table : PHashTable;  	// class table
     zend_constants : PHashTable;	// constants table */

     precision : longint;

     ticks_count : integer;

     in_execution : zend_bool;
     bailout_set : zend_bool;
     full_tables_cleanup : zend_bool;

     // for extended information support */
     no_extensions : zend_bool;

     timed_out : zend_bool;

     regular_list : THashTable;
     persistent_list : ThashTable;

     argument_stack : zend_ptr_stack;
     free_op1, free_op2 : integer;
     unary_op : integer;
     binary_op : integer;

     garbage : array[0..1] of pzval;
     garbage_ptr : integer;

     user_error_handler : pzval;
     user_error_handlers : zend_ptr_stack;

	//* timeout support */
      timeout_seconds : integer;

      lambda_count : integer;

      ini_directives : PHashTable;

       //* locale stuff */
       float_separator : char;

       reserved: array[0..3] of pointer;
   end;


const
  ZVAL_CACHE_LIST                                 = 0;

function ZEND_FAST_ALLOC: pzval;
function ALLOC_ZVAL: pzval;
procedure INIT_PZVAL(p: pzval);
function MAKE_STD_ZVAL: pzval;

procedure CheckZendErrors;
procedure ReportLinkError(FunctionName : string);

procedure ZendStubInit;

type
  ZENDStubEntry = record
    StubProc : Pointer;
    ProcVar : PPointer;
    Name : PChar;
  end;

function ZENDCall( AStubEntryIndex : DWORD ) : Pointer;


var
  PHPLib : THandle = 0;

var
 zend_ini_deactivate : function(TSRMLS_D : pointer) : integer; cdecl;

implementation

uses
  Dialogs;


function estrndup(s: PChar; len: Cardinal): PChar;
begin
  Result := _estrndup(s, len, nil, 0, nil, 0);
end;

function emalloc(size: size_t): pointer;
begin
  Result := _emalloc(size, nil, 0, nil, 0);
end;

procedure efree(ptr: pointer);
begin
  _efree(ptr, nil, 0, nil, 0);
end;

function ecalloc(nmemb: size_t; size: size_t): pointer;
begin
  Result := _ecalloc(nmemb, size, nil, 0, nil, 0);
end;

function erealloc(ptr: pointer; size: size_t; allow_failure: integer): pointer;
begin
  Result := _erealloc(ptr, size, allow_failure, nil, 0, nil, 0);
end;

function estrdup(const s: PChar): PChar;
begin
  Result := _estrdup(s, nil, 0, nil, 0);
end;

procedure REGISTER_MAIN_LONG_CONSTANT(name: PChar; lval: longint; flags: integer; TSRMLS_DC: Pointer);
begin
  zend_register_long_constant(name, length(name) + 1, lval, flags, 0, TSRMLS_DC);
end;

procedure REGISTER_MAIN_DOUBLE_CONSTANT(name: PChar; dval: double; flags: integer; TSRMLS_DC: Pointer);
begin
  zend_register_double_constant(name, length(name) + 1, dval, flags, 0, TSRMLS_DC);
end;

procedure REGISTER_MAIN_STRING_CONSTANT(name: PChar; str: PChar; flags: integer; TSRMLS_DC: Pointer);
begin
  zend_register_string_constant(name, length(name) + 1, str, flags, 0, TSRMLS_DC);
end;

procedure REGISTER_MAIN_STRINGL_CONSTANT(name: PChar; str: PChar; len: uint; flags: integer; TSRMLS_DC: Pointer);
begin
  zend_register_stringl_constant(name, length(name) + 1, str, len, flags, 0, TSRMLS_DC);
end;

procedure ZVAL_RESOURCE(value: pzval; l: longint);
begin
  value^._type := IS_RESOURCE;
  value^.value.lval := l;
end;

procedure ZVAL_BOOL(z: pzval; b: boolean);
begin
  z^._type := IS_BOOL;
  z^.value.lval := integer(b);
end;

procedure ZVAL_NULL(z: pzval);
begin
  z^._type := IS_NULL;
end;

procedure ZVAL_LONG(z: pzval; l: longint);
begin
  z^._type := IS_LONG;
  z^.value.lval := l;
end;

procedure ZVAL_DOUBLE(z: pzval; d: double);
begin
  z^._type := IS_DOUBLE;
  z^.value.dval := d;
end;

procedure ZVAL_STRING(z: pzval; s: pchar; duplicate: boolean);
var
  __s                                             : pchar;
begin
  __s := s;
  z^.value.str.len := strlen(__s);
  if duplicate then
    z^.value.str.val := estrndup(__s, z^.value.str.len)
  else
    z^.value.str.val := __s;
  z^._type := IS_STRING;
end;

procedure ZVAL_STRINGL(z: pzval; s: pchar; l: integer; duplicate: boolean);
var
  __s                                             : pchar;
  __l                                             : integer;
begin
  __s := s;
  __l := l;
  z^.value.str.len := __l;
  if duplicate then
    z^.value.str.val := estrndup(__s, __l)
  else
    z^.value.str.val := __s;
  z^._type := IS_STRING;
end;

procedure ZVAL_EMPTY_STRING(z: pzval);
begin
  z^.value.str.len := 0;
  z^.value.str.val := '';
  z^._type := IS_STRING;
end;

procedure ZVAL_TRUE(z: pzval);
begin
  z^._type := IS_BOOL;
  z^.value.lval := 1;
end;

procedure ZVAL_FALSE(z: pzval);
begin
  z^._type := IS_BOOL;
  z^.value.lval := 0;
end;

function ZENDLoaded: boolean;
begin
  Result := PHPLib <> 0;
end;

procedure UnloadZEND;
var
 H : THandle;
begin
  H := InterlockedExchange(Integer(PHPLib), 0);
  if H > 0 then
  begin
    FreeLibrary(H);
  end;
end;


  procedure ZendStub_tsrm_startup;                          asm mov eax,    0; call ZendCall; jmp eax; end;
  procedure ZendStub_ts_allocate_id;                        asm mov eax,    1; call ZendCall; jmp eax; end;
  procedure ZendStub_ts_free_id;                            asm mov eax,    2; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_strndup;                          asm mov eax,    3; call ZendCall; jmp eax; end;
  procedure ZendStub__emalloc;                              asm mov eax,    4; call ZendCall; jmp eax; end;
  procedure ZendStub__efree;                                asm mov eax,    5; call ZendCall; jmp eax; end;
  procedure ZendStub__ecalloc;                              asm mov eax,    6; call ZendCall; jmp eax; end;
  procedure ZendStub__erealloc;                             asm mov eax,    7; call ZendCall; jmp eax; end;
  procedure ZendStub__estrdup;                              asm mov eax,    8; call ZendCall; jmp eax; end;
  procedure ZendStub__estrndup;                             asm mov eax,    9; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_set_memory_limit;                 asm mov eax,   10; call ZendCall; jmp eax; end;
  procedure ZendStub_start_memory_manager;                  asm mov eax,   11; call ZendCall; jmp eax; end;
  procedure ZendStub_shutdown_memory_manager;               asm mov eax,   12; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_init;                        asm mov eax,   13; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_init_ex;                     asm mov eax,   14; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_destroy;                     asm mov eax,   15; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_clean;                       asm mov eax,   16; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_add_or_update;               asm mov eax,   17; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_quick_add_or_update;         asm mov eax,   18; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_index_update_or_next_insert; asm mov eax,   19; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_add_empty_element;           asm mov eax,   20; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_graceful_destroy;            asm mov eax,   21; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_graceful_reverse_destroy;    asm mov eax,   22; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_apply;                       asm mov eax,   23; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_apply_with_argument;         asm mov eax,   24; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_reverse_apply;               asm mov eax,   25; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_del_key_or_index;            asm mov eax,   26; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_get_hash_value;                   asm mov eax,   27; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_find;                        asm mov eax,   28; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_quick_find;                  asm mov eax,   29; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_index_find;                  asm mov eax,   30; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_exists;                      asm mov eax,   31; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_index_exists;                asm mov eax,   32; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_next_free_element;           asm mov eax,   33; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_move_forward_ex;             asm mov eax,   34; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_move_backwards_ex;           asm mov eax,   35; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_get_current_key_ex;          asm mov eax,   36; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_get_current_key_type_ex;     asm mov eax,   37; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_get_current_data_ex;         asm mov eax,   38; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_internal_pointer_reset_ex;   asm mov eax,   39; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_internal_pointer_end_ex;     asm mov eax,   40; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_copy;                        asm mov eax,   41; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_merge;                       asm mov eax,   42; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_sort;                        asm mov eax,   43; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_compare;                     asm mov eax,   44; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_minmax;                      asm mov eax,   45; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_num_elements;                asm mov eax,   46; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_rehash;                      asm mov eax,   47; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_hash_func;                        asm mov eax,   48; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_get_constant;                     asm mov eax,   49; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_long_constant;           asm mov eax,   50; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_double_constant;         asm mov eax,   51; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_string_constant;         asm mov eax,   52; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_stringl_constant;        asm mov eax,   53; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_constant;                asm mov eax,   54; call ZendCall; jmp eax; end;
  procedure ZendStub_tsrm_shutdown;                         asm mov eax,   55; call ZendCall; jmp eax; end;
  procedure ZendStub_ts_resource_ex;                        asm mov eax,   56; call ZendCall; jmp eax; end;
  procedure ZendStub_ts_free_thread;                        asm mov eax,   57; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_error;                            asm mov eax,   58; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_error_cb;                         asm mov eax,   59; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_eval_string;                      asm mov eax,   60; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_make_compiled_string_description; asm mov eax,   61; call ZendCall; jmp eax; end;
  procedure ZendStub__zval_dtor;                            asm mov eax,   62; call ZendCall; jmp eax; end;
  procedure ZendStub__zval_copy_ctor;                       asm mov eax,   63; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_print_variable;                   asm mov eax,   64; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_init;                       asm mov eax,   65; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_push;                       asm mov eax,   66; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_top;                        asm mov eax,   67; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_del_top;                    asm mov eax,   68; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_int_top;                    asm mov eax,   69; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_is_empty;                   asm mov eax,   70; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_destroy;                    asm mov eax,   71; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_base;                       asm mov eax,   72; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_count;                      asm mov eax,   73; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_apply;                      asm mov eax,   74; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_stack_apply_with_argument;        asm mov eax,   75; call ZendCall; jmp eax; end;
  procedure ZendStub__convert_to_string;                    asm mov eax,   76; call ZendCall; jmp eax; end;
  procedure ZendStub_add_function;                          asm mov eax,   77; call ZendCall; jmp eax; end;
  procedure ZendStub_sub_function;                          asm mov eax,   78; call ZendCall; jmp eax; end;
  procedure ZendStub_mul_function;                          asm mov eax,   79; call ZendCall; jmp eax; end;
  procedure ZendStub_div_function;                          asm mov eax,   80; call ZendCall; jmp eax; end;
  procedure ZendStub_mod_function;                          asm mov eax,   81; call ZendCall; jmp eax; end;
  procedure ZendStub_boolean_xor_function;                  asm mov eax,   82; call ZendCall; jmp eax; end;
  procedure ZendStub_boolean_not_function;                  asm mov eax,   83; call ZendCall; jmp eax; end;
  procedure ZendStub_bitwise_not_function;                  asm mov eax,   84; call ZendCall; jmp eax; end;
  procedure ZendStub_bitwise_or_function;                   asm mov eax,   85; call ZendCall; jmp eax; end;
  procedure ZendStub_bitwise_and_function;                  asm mov eax,   86; call ZendCall; jmp eax; end;
  procedure ZendStub_bitwise_xor_function;                  asm mov eax,   87; call ZendCall; jmp eax; end;
  procedure ZendStub_shift_left_function;                   asm mov eax,   88; call ZendCall; jmp eax; end;
  procedure ZendStub_shift_right_function;                  asm mov eax,   89; call ZendCall; jmp eax; end;
  procedure ZendStub_concat_function;                       asm mov eax,   90; call ZendCall; jmp eax; end;
  procedure ZendStub_is_equal_function;                     asm mov eax,   91; call ZendCall; jmp eax; end;
  procedure ZendStub_is_identical_function;                 asm mov eax,   92; call ZendCall; jmp eax; end;
  procedure ZendStub_is_not_identical_function;             asm mov eax,   93; call ZendCall; jmp eax; end;
  procedure ZendStub_is_not_equal_function;                 asm mov eax,   94; call ZendCall; jmp eax; end;
  procedure ZendStub_is_smaller_function;                   asm mov eax,   95; call ZendCall; jmp eax; end;
  procedure ZendStub_is_smaller_or_equal_function;          asm mov eax,   96; call ZendCall; jmp eax; end;
  procedure ZendStub_increment_function;                    asm mov eax,   97; call ZendCall; jmp eax; end;
  procedure ZendStub_decrement_function;                    asm mov eax,   98; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_scalar_to_number;              asm mov eax,   99; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_long;                       asm mov eax,  100; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_double;                     asm mov eax,  101; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_long_base;                  asm mov eax,  102; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_null;                       asm mov eax,  103; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_boolean;                    asm mov eax,  104; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_array;                      asm mov eax,  105; call ZendCall; jmp eax; end;
  procedure ZendStub_convert_to_object;                     asm mov eax,  106; call ZendCall; jmp eax; end;
  procedure ZendStub_add_char_to_string;                    asm mov eax,  107; call ZendCall; jmp eax; end;
  procedure ZendStub_add_string_to_string;                  asm mov eax,  108; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_string_to_double;                 asm mov eax,  109; call ZendCall; jmp eax; end;
  procedure ZendStub_zval_is_true;                          asm mov eax,  110; call ZendCall; jmp eax; end;
  procedure ZendStub_compare_function;                      asm mov eax,  111; call ZendCall; jmp eax; end;
  procedure ZendStub_numeric_compare_function;              asm mov eax,  112; call ZendCall; jmp eax; end;
  procedure ZendStub_string_compare_function;               asm mov eax,  113; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_str_tolower;                      asm mov eax,  114; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_zval_strcmp;               asm mov eax,  115; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_zval_strncmp;              asm mov eax,  116; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_zval_strcasecmp;           asm mov eax,  117; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_zval_strncasecmp;          asm mov eax,  118; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_strcmp;                    asm mov eax,  119; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_strncmp;                   asm mov eax,  120; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_strcasecmp;                asm mov eax,  121; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_binary_strncasecmp;               asm mov eax,  122; call ZendCall; jmp eax; end;
  procedure ZendStub_zendi_smart_strcmp;                    asm mov eax,  123; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_compare_symbol_tables;            asm mov eax,  124; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_compare_arrays;                   asm mov eax,  125; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_compare_objects;                  asm mov eax,  126; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_atoi;                             asm mov eax,  127; call ZendCall; jmp eax; end;
  procedure ZendStub_get_active_function_name;              asm mov eax,  128; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_get_executed_filename;            asm mov eax,  129; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_set_timeout;                      asm mov eax,  130; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_unset_timeout;                    asm mov eax,  131; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_timeout;                          asm mov eax,  132; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_highlight;                        asm mov eax,  133; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_strip;                            asm mov eax,  134; call ZendCall; jmp eax; end;
  procedure ZendStub_highlight_file;                        asm mov eax,  135; call ZendCall; jmp eax; end;
  procedure ZendStub_highlight_string;                      asm mov eax,  136; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_html_putc;                        asm mov eax,  137; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_html_puts;                        asm mov eax,  138; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_indent;                           asm mov eax,  139; call ZendCall; jmp eax; end;
  procedure ZendStub__zend_get_parameters_array_ex;         asm mov eax,  140; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_ini_refresh_caches;               asm mov eax,  141; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_alter_ini_entry;                  asm mov eax,  142; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_restore_ini_entry;                asm mov eax,  143; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_ini_long;                         asm mov eax,  144; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_ini_double;                       asm mov eax,  145; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_ini_string;                       asm mov eax,  146; call ZendCall; jmp eax; end;
  procedure ZendStub_compile_string;                        asm mov eax,  147; call ZendCall; jmp eax; end;
  procedure ZendStub_execute;                               asm mov eax,  148; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_wrong_param_count;                asm mov eax,  149; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_long_ex;                  asm mov eax,  150; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_null_ex;                  asm mov eax,  151; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_bool_ex;                  asm mov eax,  152; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_resource_ex;              asm mov eax,  153; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_double_ex;                asm mov eax,  154; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_string_ex;                asm mov eax,  155; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_stringl_ex;               asm mov eax,  156; call ZendCall; jmp eax; end;
  procedure ZendStub_add_property_zval_ex;                  asm mov eax,  157; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_long_ex;                     asm mov eax,  158; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_null_ex;                     asm mov eax,  159; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_bool_ex;                     asm mov eax,  160; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_resource_ex;                 asm mov eax,  161; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_double_ex;                   asm mov eax,  162; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_string_ex;                   asm mov eax,  163; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_stringl_ex;                  asm mov eax,  164; call ZendCall; jmp eax; end;
  procedure ZendStub_add_assoc_zval_ex;                     asm mov eax,  165; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_long;                        asm mov eax,  166; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_null;                        asm mov eax,  167; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_bool;                        asm mov eax,  168; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_resource;                    asm mov eax,  169; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_double;                      asm mov eax,  170; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_string;                      asm mov eax,  171; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_stringl;                     asm mov eax,  172; call ZendCall; jmp eax; end;
  procedure ZendStub_add_index_zval;                        asm mov eax,  173; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_long;                   asm mov eax,  174; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_null;                   asm mov eax,  175; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_bool;                   asm mov eax,  176; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_resource;               asm mov eax,  177; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_double;                 asm mov eax,  178; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_string;                 asm mov eax,  179; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_stringl;                asm mov eax,  180; call ZendCall; jmp eax; end;
  procedure ZendStub_add_next_index_zval;                   asm mov eax,  181; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_assoc_string_ex;               asm mov eax,  182; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_assoc_stringl_ex;              asm mov eax,  183; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_index_long;                    asm mov eax,  184; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_index_double;                  asm mov eax,  185; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_index_string;                  asm mov eax,  186; call ZendCall; jmp eax; end;
  procedure ZendStub_add_get_index_stringl;                 asm mov eax,  187; call ZendCall; jmp eax; end;
  procedure ZendStub__array_init;                           asm mov eax,  188; call ZendCall; jmp eax; end;
  procedure ZendStub__object_init;                          asm mov eax,  189; call ZendCall; jmp eax; end;
  procedure ZendStub__object_init_ex;                       asm mov eax,  190; call ZendCall; jmp eax; end;
  procedure ZendStub__object_and_properties_init;           asm mov eax,  191; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_internal_class;          asm mov eax,  192; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_register_internal_class_ex;       asm mov eax,  193; call ZendCall; jmp eax; end;
  procedure ZendStub_get_zend_version;                      asm mov eax,  194; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_make_printable_zval;              asm mov eax,  195; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_print_zval;                       asm mov eax,  196; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_print_zval_r;                     asm mov eax,  197; call ZendCall; jmp eax; end;
  procedure ZendStub_zend_output_debug_string;              asm mov eax,  198; call ZendCall; jmp eax; end;
  procedure ZendStub_ZendGetParameters;                     asm mov eax,  199; call ZendCall; jmp eax; end;


const
  ZendStubEntryCount = 200;
  ZendStubTable : Array [0..ZendStubEntryCount-1] of ZendStubEntry = (
  	(StubProc: @ZendStub_tsrm_startup;                           ProcVar: @@tsrm_startup;                           Name: 'tsrm_startup'),
  	(StubProc: @ZendStub_ts_allocate_id;                         ProcVar: @@ts_allocate_id;                         Name: 'ts_allocate_id'),
  	(StubProc: @ZendStub_ts_free_id;                             ProcVar: @@ts_free_id;                             Name: 'ts_free_id'),
  	(StubProc: @ZendStub_zend_strndup;                           ProcVar: @@zend_strndup;                           Name: 'zend_strndup'),
  	(StubProc: @ZendStub__emalloc;                               ProcVar: @@_emalloc;                               Name: '_emalloc'),
  	(StubProc: @ZendStub__efree;                                 ProcVar: @@_efree;                                 Name: '_efree'),
  	(StubProc: @ZendStub__ecalloc;                               ProcVar: @@_ecalloc;                               Name: '_ecalloc'),
  	(StubProc: @ZendStub__erealloc;                              ProcVar: @@_erealloc;                              Name: '_erealloc'),
  	(StubProc: @ZendStub__estrdup;                               ProcVar: @@_estrdup;                               Name: '_estrdup'),
  	(StubProc: @ZendStub__estrndup;                              ProcVar: @@_estrndup;                              Name: '_estrndup'),
  	(StubProc: @ZendStub_zend_set_memory_limit;                  ProcVar: @@zend_set_memory_limit;                  Name: 'zend_set_memory_limit'),
  	(StubProc: @ZendStub_start_memory_manager;                   ProcVar: @@start_memory_manager;                   Name: 'start_memory_manager'),
  	(StubProc: @ZendStub_shutdown_memory_manager;                ProcVar: @@shutdown_memory_manager;                Name: 'shutdown_memory_manager'),
  	(StubProc: @ZendStub_zend_hash_init;                         ProcVar: @@zend_hash_init;                         Name: 'zend_hash_init'),
  	(StubProc: @ZendStub_zend_hash_init_ex;                      ProcVar: @@zend_hash_init_ex;                      Name: 'zend_hash_init_ex'),
  	(StubProc: @ZendStub_zend_hash_destroy;                      ProcVar: @@zend_hash_destroy;                      Name: 'zend_hash_destroy'),
  	(StubProc: @ZendStub_zend_hash_clean;                        ProcVar: @@zend_hash_clean;                        Name: 'zend_hash_clean'),
  	(StubProc: @ZendStub_zend_hash_add_or_update;                ProcVar: @@zend_hash_add_or_update;                Name: 'zend_hash_add_or_update'),
  	(StubProc: @ZendStub_zend_hash_quick_add_or_update;          ProcVar: @@zend_hash_quick_add_or_update;          Name: 'zend_hash_quick_add_or_update'),
  	(StubProc: @ZendStub_zend_hash_index_update_or_next_insert;  ProcVar: @@zend_hash_index_update_or_next_insert;  Name: 'zend_hash_index_update_or_next_insert'),
  	(StubProc: @ZendStub_zend_hash_add_empty_element;            ProcVar: @@zend_hash_add_empty_element;            Name: 'zend_hash_add_empty_element'),
  	(StubProc: @ZendStub_zend_hash_graceful_destroy;             ProcVar: @@zend_hash_graceful_destroy;             Name: 'zend_hash_graceful_destroy'),
  	(StubProc: @ZendStub_zend_hash_graceful_reverse_destroy;     ProcVar: @@zend_hash_graceful_reverse_destroy;     Name: 'zend_hash_graceful_reverse_destroy'),
  	(StubProc: @ZendStub_zend_hash_apply;                        ProcVar: @@zend_hash_apply;                        Name: 'zend_hash_apply'),
  	(StubProc: @ZendStub_zend_hash_apply_with_argument;          ProcVar: @@zend_hash_apply_with_argument;          Name: 'zend_hash_apply_with_argument'),
  	(StubProc: @ZendStub_zend_hash_reverse_apply;                ProcVar: @@zend_hash_reverse_apply;                Name: 'zend_hash_reverse_apply'),
  	(StubProc: @ZendStub_zend_hash_del_key_or_index;             ProcVar: @@zend_hash_del_key_or_index;             Name: 'zend_hash_del_key_or_index'),
  	(StubProc: @ZendStub_zend_get_hash_value;                    ProcVar: @@zend_get_hash_value;                    Name: 'zend_get_hash_value'),
  	(StubProc: @ZendStub_zend_hash_find;                         ProcVar: @@zend_hash_find;                         Name: 'zend_hash_find'),
  	(StubProc: @ZendStub_zend_hash_quick_find;                   ProcVar: @@zend_hash_quick_find;                   Name: 'zend_hash_quick_find'),
  	(StubProc: @ZendStub_zend_hash_index_find;                   ProcVar: @@zend_hash_index_find;                   Name: 'zend_hash_index_find'),
  	(StubProc: @ZendStub_zend_hash_exists;                       ProcVar: @@zend_hash_exists;                       Name: 'zend_hash_exists'),
  	(StubProc: @ZendStub_zend_hash_index_exists;                 ProcVar: @@zend_hash_index_exists;                 Name: 'zend_hash_index_exists'),
  	(StubProc: @ZendStub_zend_hash_next_free_element;            ProcVar: @@zend_hash_next_free_element;            Name: 'zend_hash_next_free_element'),
  	(StubProc: @ZendStub_zend_hash_move_forward_ex;              ProcVar: @@zend_hash_move_forward_ex;              Name: 'zend_hash_move_forward_ex'),
  	(StubProc: @ZendStub_zend_hash_move_backwards_ex;            ProcVar: @@zend_hash_move_backwards_ex;            Name: 'zend_hash_move_backwards_ex'),
  	(StubProc: @ZendStub_zend_hash_get_current_key_ex;           ProcVar: @@zend_hash_get_current_key_ex;           Name: 'zend_hash_get_current_key_ex'),
  	(StubProc: @ZendStub_zend_hash_get_current_key_type_ex;      ProcVar: @@zend_hash_get_current_key_type_ex;      Name: 'zend_hash_get_current_key_type_ex'),
  	(StubProc: @ZendStub_zend_hash_get_current_data_ex;          ProcVar: @@zend_hash_get_current_data_ex;          Name: 'zend_hash_get_current_data_ex'),
  	(StubProc: @ZendStub_zend_hash_internal_pointer_reset_ex;    ProcVar: @@zend_hash_internal_pointer_reset_ex;    Name: 'zend_hash_internal_pointer_reset_ex'),
  	(StubProc: @ZendStub_zend_hash_internal_pointer_end_ex;      ProcVar: @@zend_hash_internal_pointer_end_ex;      Name: 'zend_hash_internal_pointer_end_ex'),
  	(StubProc: @ZendStub_zend_hash_copy;                         ProcVar: @@zend_hash_copy;                         Name: 'zend_hash_copy'),
  	(StubProc: @ZendStub_zend_hash_merge;                        ProcVar: @@zend_hash_merge;                        Name: 'zend_hash_merge'),
  	(StubProc: @ZendStub_zend_hash_sort;                         ProcVar: @@zend_hash_sort;                         Name: 'zend_hash_sort'),
  	(StubProc: @ZendStub_zend_hash_compare;                      ProcVar: @@zend_hash_compare;                      Name: 'zend_hash_compare'),
  	(StubProc: @ZendStub_zend_hash_minmax;                       ProcVar: @@zend_hash_minmax;                       Name: 'zend_hash_minmax'),
  	(StubProc: @ZendStub_zend_hash_num_elements;                 ProcVar: @@zend_hash_num_elements;                 Name: 'zend_hash_num_elements'),
  	(StubProc: @ZendStub_zend_hash_rehash;                       ProcVar: @@zend_hash_rehash;                       Name: 'zend_hash_rehash'),
  	(StubProc: @ZendStub_zend_hash_func;                         ProcVar: @@zend_hash_func;                         Name: 'zend_hash_func'),
  	(StubProc: @ZendStub_zend_get_constant;                      ProcVar: @@zend_get_constant;                      Name: 'zend_get_constant'),
  	(StubProc: @ZendStub_zend_register_long_constant;            ProcVar: @@zend_register_long_constant;            Name: 'zend_register_long_constant'),
  	(StubProc: @ZendStub_zend_register_double_constant;          ProcVar: @@zend_register_double_constant;          Name: 'zend_register_double_constant'),
  	(StubProc: @ZendStub_zend_register_string_constant;          ProcVar: @@zend_register_string_constant;          Name: 'zend_register_string_constant'),
  	(StubProc: @ZendStub_zend_register_stringl_constant;         ProcVar: @@zend_register_stringl_constant;         Name: 'zend_register_stringl_constant'),
  	(StubProc: @ZendStub_zend_register_constant;                 ProcVar: @@zend_register_constant;                 Name: 'zend_register_constant'),
  	(StubProc: @ZendStub_tsrm_shutdown;                          ProcVar: @@tsrm_shutdown;                          Name: 'tsrm_shutdown'),
  	(StubProc: @ZendStub_ts_resource_ex;                         ProcVar: @@ts_resource_ex;                         Name: 'ts_resource_ex'),
  	(StubProc: @ZendStub_ts_free_thread;                         ProcVar: @@ts_free_thread;                         Name: 'ts_free_thread'),
  	(StubProc: @ZendStub_zend_error;                             ProcVar: @@zend_error;                             Name: 'zend_error'),
  	(StubProc: @ZendStub_zend_error_cb;                          ProcVar: @@zend_error_cb;                          Name: 'zend_error_cb'),
  	(StubProc: @ZendStub_zend_eval_string;                       ProcVar: @@zend_eval_string;                       Name: 'zend_eval_string'),
  	(StubProc: @ZendStub_zend_make_compiled_string_description;  ProcVar: @@zend_make_compiled_string_description;  Name: 'zend_make_compiled_string_description'),
  	(StubProc: @ZendStub__zval_dtor;                             ProcVar: @@_zval_dtor;                             Name: '_zval_dtor'),
  	(StubProc: @ZendStub__zval_copy_ctor;                        ProcVar: @@_zval_copy_ctor;                        Name: '_zval_copy_ctor'),
  	(StubProc: @ZendStub_zend_print_variable;                    ProcVar: @@zend_print_variable;                    Name: 'zend_print_variable'),
  	(StubProc: @ZendStub_zend_stack_init;                        ProcVar: @@zend_stack_init;                        Name: 'zend_stack_init'),
  	(StubProc: @ZendStub_zend_stack_push;                        ProcVar: @@zend_stack_push;                        Name: 'zend_stack_push'),
  	(StubProc: @ZendStub_zend_stack_top;                         ProcVar: @@zend_stack_top;                         Name: 'zend_stack_top'),
  	(StubProc: @ZendStub_zend_stack_del_top;                     ProcVar: @@zend_stack_del_top;                     Name: 'zend_stack_del_top'),
  	(StubProc: @ZendStub_zend_stack_int_top;                     ProcVar: @@zend_stack_int_top;                     Name: 'zend_stack_int_top'),
  	(StubProc: @ZendStub_zend_stack_is_empty;                    ProcVar: @@zend_stack_is_empty;                    Name: 'zend_stack_is_empty'),
  	(StubProc: @ZendStub_zend_stack_destroy;                     ProcVar: @@zend_stack_destroy;                     Name: 'zend_stack_destroy'),
  	(StubProc: @ZendStub_zend_stack_base;                        ProcVar: @@zend_stack_base;                        Name: 'zend_stack_base'),
  	(StubProc: @ZendStub_zend_stack_count;                       ProcVar: @@zend_stack_count;                       Name: 'zend_stack_count'),
  	(StubProc: @ZendStub_zend_stack_apply;                       ProcVar: @@zend_stack_apply;                       Name: 'zend_stack_apply'),
  	(StubProc: @ZendStub_zend_stack_apply_with_argument;         ProcVar: @@zend_stack_apply_with_argument;         Name: 'zend_stack_apply_with_argument'),
  	(StubProc: @ZendStub__convert_to_string;                     ProcVar: @@_convert_to_string;                     Name: '_convert_to_string'),
  	(StubProc: @ZendStub_add_function;                           ProcVar: @@add_function;                           Name: 'add_function'),
  	(StubProc: @ZendStub_sub_function;                           ProcVar: @@sub_function;                           Name: 'sub_function'),
  	(StubProc: @ZendStub_mul_function;                           ProcVar: @@mul_function;                           Name: 'mul_function'),
  	(StubProc: @ZendStub_div_function;                           ProcVar: @@div_function;                           Name: 'div_function'),
  	(StubProc: @ZendStub_mod_function;                           ProcVar: @@mod_function;                           Name: 'mod_function'),
  	(StubProc: @ZendStub_boolean_xor_function;                   ProcVar: @@boolean_xor_function;                   Name: 'boolean_xor_function'),
  	(StubProc: @ZendStub_boolean_not_function;                   ProcVar: @@boolean_not_function;                   Name: 'boolean_not_function'),
  	(StubProc: @ZendStub_bitwise_not_function;                   ProcVar: @@bitwise_not_function;                   Name: 'bitwise_not_function'),
  	(StubProc: @ZendStub_bitwise_or_function;                    ProcVar: @@bitwise_or_function;                    Name: 'bitwise_or_function'),
  	(StubProc: @ZendStub_bitwise_and_function;                   ProcVar: @@bitwise_and_function;                   Name: 'bitwise_and_function'),
  	(StubProc: @ZendStub_bitwise_xor_function;                   ProcVar: @@bitwise_xor_function;                   Name: 'bitwise_xor_function'),
  	(StubProc: @ZendStub_shift_left_function;                    ProcVar: @@shift_left_function;                    Name: 'shift_left_function'),
  	(StubProc: @ZendStub_shift_right_function;                   ProcVar: @@shift_right_function;                   Name: 'shift_right_function'),
  	(StubProc: @ZendStub_concat_function;                        ProcVar: @@concat_function;                        Name: 'concat_function'),
  	(StubProc: @ZendStub_is_equal_function;                      ProcVar: @@is_equal_function;                      Name: 'is_equal_function'),
  	(StubProc: @ZendStub_is_identical_function;                  ProcVar: @@is_identical_function;                  Name: 'is_identical_function'),
  	(StubProc: @ZendStub_is_not_identical_function;              ProcVar: @@is_not_identical_function;              Name: 'is_not_identical_function'),
  	(StubProc: @ZendStub_is_not_equal_function;                  ProcVar: @@is_not_equal_function;                  Name: 'is_not_equal_function'),
  	(StubProc: @ZendStub_is_smaller_function;                    ProcVar: @@is_smaller_function;                    Name: 'is_smaller_function'),
  	(StubProc: @ZendStub_is_smaller_or_equal_function;           ProcVar: @@is_smaller_or_equal_function;           Name: 'is_smaller_or_equal_function'),
  	(StubProc: @ZendStub_increment_function;                     ProcVar: @@increment_function;                     Name: 'increment_function'),
  	(StubProc: @ZendStub_decrement_function;                     ProcVar: @@decrement_function;                     Name: 'decrement_function'),
  	(StubProc: @ZendStub_convert_scalar_to_number;               ProcVar: @@convert_scalar_to_number;               Name: 'convert_scalar_to_number'),
  	(StubProc: @ZendStub_convert_to_long;                        ProcVar: @@convert_to_long;                        Name: 'convert_to_long'),
  	(StubProc: @ZendStub_convert_to_double;                      ProcVar: @@convert_to_double;                      Name: 'convert_to_double'),
  	(StubProc: @ZendStub_convert_to_long_base;                   ProcVar: @@convert_to_long_base;                   Name: 'convert_to_long_base'),
  	(StubProc: @ZendStub_convert_to_null;                        ProcVar: @@convert_to_null;                        Name: 'convert_to_null'),
  	(StubProc: @ZendStub_convert_to_boolean;                     ProcVar: @@convert_to_boolean;                     Name: 'convert_to_boolean'),
  	(StubProc: @ZendStub_convert_to_array;                       ProcVar: @@convert_to_array;                       Name: 'convert_to_array'),
  	(StubProc: @ZendStub_convert_to_object;                      ProcVar: @@convert_to_object;                      Name: 'convert_to_object'),
  	(StubProc: @ZendStub_add_char_to_string;                     ProcVar: @@add_char_to_string;                     Name: 'add_char_to_string'),
  	(StubProc: @ZendStub_add_string_to_string;                   ProcVar: @@add_string_to_string;                   Name: 'add_string_to_string'),
  	(StubProc: @ZendStub_zend_string_to_double;                  ProcVar: @@zend_string_to_double;                  Name: 'zend_string_to_double'),
  	(StubProc: @ZendStub_zval_is_true;                           ProcVar: @@zval_is_true;                           Name: 'zval_is_true'),
  	(StubProc: @ZendStub_compare_function;                       ProcVar: @@compare_function;                       Name: 'compare_function'),
  	(StubProc: @ZendStub_numeric_compare_function;               ProcVar: @@numeric_compare_function;               Name: 'numeric_compare_function'),
  	(StubProc: @ZendStub_string_compare_function;                ProcVar: @@string_compare_function;                Name: 'string_compare_function'),
  	(StubProc: @ZendStub_zend_str_tolower;                       ProcVar: @@zend_str_tolower;                       Name: 'zend_str_tolower'),
  	(StubProc: @ZendStub_zend_binary_zval_strcmp;                ProcVar: @@zend_binary_zval_strcmp;                Name: 'zend_binary_zval_strcmp'),
  	(StubProc: @ZendStub_zend_binary_zval_strncmp;               ProcVar: @@zend_binary_zval_strncmp;               Name: 'zend_binary_zval_strncmp'),
  	(StubProc: @ZendStub_zend_binary_zval_strcasecmp;            ProcVar: @@zend_binary_zval_strcasecmp;            Name: 'zend_binary_zval_strcasecmp'),
  	(StubProc: @ZendStub_zend_binary_zval_strncasecmp;           ProcVar: @@zend_binary_zval_strncasecmp;           Name: 'zend_binary_zval_strncasecmp'),
  	(StubProc: @ZendStub_zend_binary_strcmp;                     ProcVar: @@zend_binary_strcmp;                     Name: 'zend_binary_strcmp'),
  	(StubProc: @ZendStub_zend_binary_strncmp;                    ProcVar: @@zend_binary_strncmp;                    Name: 'zend_binary_strncmp'),
  	(StubProc: @ZendStub_zend_binary_strcasecmp;                 ProcVar: @@zend_binary_strcasecmp;                 Name: 'zend_binary_strcasecmp'),
  	(StubProc: @ZendStub_zend_binary_strncasecmp;                ProcVar: @@zend_binary_strncasecmp;                Name: 'zend_binary_strncasecmp'),
  	(StubProc: @ZendStub_zendi_smart_strcmp;                     ProcVar: @@zendi_smart_strcmp;                     Name: 'zendi_smart_strcmp'),
  	(StubProc: @ZendStub_zend_compare_symbol_tables;             ProcVar: @@zend_compare_symbol_tables;             Name: 'zend_compare_symbol_tables'),
  	(StubProc: @ZendStub_zend_compare_arrays;                    ProcVar: @@zend_compare_arrays;                    Name: 'zend_compare_arrays'),
  	(StubProc: @ZendStub_zend_compare_objects;                   ProcVar: @@zend_compare_objects;                   Name: 'zend_compare_objects'),
  	(StubProc: @ZendStub_zend_atoi;                              ProcVar: @@zend_atoi;                              Name: 'zend_atoi'),
  	(StubProc: @ZendStub_get_active_function_name;               ProcVar: @@get_active_function_name;               Name: 'get_active_function_name'),
  	(StubProc: @ZendStub_zend_get_executed_filename;             ProcVar: @@zend_get_executed_filename;             Name: 'zend_get_executed_filename'),
  	(StubProc: @ZendStub_zend_set_timeout;                       ProcVar: @@zend_set_timeout;                       Name: 'zend_set_timeout'),
  	(StubProc: @ZendStub_zend_unset_timeout;                     ProcVar: @@zend_unset_timeout;                     Name: 'zend_unset_timeout'),
  	(StubProc: @ZendStub_zend_timeout;                           ProcVar: @@zend_timeout;                           Name: 'zend_timeout'),
  	(StubProc: @ZendStub_zend_highlight;                         ProcVar: @@zend_highlight;                         Name: 'zend_highlight'),
  	(StubProc: @ZendStub_zend_strip;                             ProcVar: @@zend_strip;                             Name: 'zend_strip'),
  	(StubProc: @ZendStub_highlight_file;                         ProcVar: @@highlight_file;                         Name: 'highlight_file'),
  	(StubProc: @ZendStub_highlight_string;                       ProcVar: @@highlight_string;                       Name: 'highlight_string'),
  	(StubProc: @ZendStub_zend_html_putc;                         ProcVar: @@zend_html_putc;                         Name: 'zend_html_putc'),
  	(StubProc: @ZendStub_zend_html_puts;                         ProcVar: @@zend_html_puts;                         Name: 'zend_html_puts'),
  	(StubProc: @ZendStub_zend_indent;                            ProcVar: @@zend_indent;                            Name: 'zend_indent'),
  	(StubProc: @ZendStub__zend_get_parameters_array_ex;          ProcVar: @@_zend_get_parameters_array_ex;          Name: '_zend_get_parameters_array_ex'),
  	(StubProc: @ZendStub_zend_ini_refresh_caches;                ProcVar: @@zend_ini_refresh_caches;                Name: 'zend_ini_refresh_caches'),
  	(StubProc: @ZendStub_zend_alter_ini_entry;                   ProcVar: @@zend_alter_ini_entry;                   Name: 'zend_alter_ini_entry'),
  	(StubProc: @ZendStub_zend_restore_ini_entry;                 ProcVar: @@zend_restore_ini_entry;                 Name: 'zend_restore_ini_entry'),
  	(StubProc: @ZendStub_zend_ini_long;                          ProcVar: @@zend_ini_long;                          Name: 'zend_ini_long'),
  	(StubProc: @ZendStub_zend_ini_double;                        ProcVar: @@zend_ini_double;                        Name: 'zend_ini_double'),
  	(StubProc: @ZendStub_zend_ini_string;                        ProcVar: @@zend_ini_string;                        Name: 'zend_ini_string'),
  	(StubProc: @ZendStub_compile_string;                         ProcVar: @@compile_string;                         Name: 'compile_string'),
  	(StubProc: @ZendStub_execute;                                ProcVar: @@execute;                                Name: 'execute'),
  	(StubProc: @ZendStub_zend_wrong_param_count;                 ProcVar: @@zend_wrong_param_count;                 Name: 'zend_wrong_param_count'),
  	(StubProc: @ZendStub_add_property_long_ex;                   ProcVar: @@add_property_long_ex;                   Name: 'add_property_long_ex'),
  	(StubProc: @ZendStub_add_property_null_ex;                   ProcVar: @@add_property_null_ex;                   Name: 'add_property_null_ex'),
  	(StubProc: @ZendStub_add_property_bool_ex;                   ProcVar: @@add_property_bool_ex;                   Name: 'add_property_bool_ex'),
  	(StubProc: @ZendStub_add_property_resource_ex;               ProcVar: @@add_property_resource_ex;               Name: 'add_property_resource_ex'),
  	(StubProc: @ZendStub_add_property_double_ex;                 ProcVar: @@add_property_double_ex;                 Name: 'add_property_double_ex'),
  	(StubProc: @ZendStub_add_property_string_ex;                 ProcVar: @@add_property_string_ex;                 Name: 'add_property_string_ex'),
  	(StubProc: @ZendStub_add_property_stringl_ex;                ProcVar: @@add_property_stringl_ex;                Name: 'add_property_stringl_ex'),
  	(StubProc: @ZendStub_add_property_zval_ex;                   ProcVar: @@add_property_zval_ex;                   Name: 'add_property_zval_ex'),
  	(StubProc: @ZendStub_add_assoc_long_ex;                      ProcVar: @@add_assoc_long_ex;                      Name: 'add_assoc_long_ex'),
  	(StubProc: @ZendStub_add_assoc_null_ex;                      ProcVar: @@add_assoc_null_ex;                      Name: 'add_assoc_null_ex'),
  	(StubProc: @ZendStub_add_assoc_bool_ex;                      ProcVar: @@add_assoc_bool_ex;                      Name: 'add_assoc_bool_ex'),
  	(StubProc: @ZendStub_add_assoc_resource_ex;                  ProcVar: @@add_assoc_resource_ex;                  Name: 'add_assoc_resource_ex'),
  	(StubProc: @ZendStub_add_assoc_double_ex;                    ProcVar: @@add_assoc_double_ex;                    Name: 'add_assoc_double_ex'),
  	(StubProc: @ZendStub_add_assoc_string_ex;                    ProcVar: @@add_assoc_string_ex;                    Name: 'add_assoc_string_ex'),
  	(StubProc: @ZendStub_add_assoc_stringl_ex;                   ProcVar: @@add_assoc_stringl_ex;                   Name: 'add_assoc_stringl_ex'),
  	(StubProc: @ZendStub_add_assoc_zval_ex;                      ProcVar: @@add_assoc_zval_ex;                      Name: 'add_assoc_zval_ex'),
  	(StubProc: @ZendStub_add_index_long;                         ProcVar: @@add_index_long;                         Name: 'add_index_long'),
  	(StubProc: @ZendStub_add_index_null;                         ProcVar: @@add_index_null;                         Name: 'add_index_null'),
  	(StubProc: @ZendStub_add_index_bool;                         ProcVar: @@add_index_bool;                         Name: 'add_index_bool'),
  	(StubProc: @ZendStub_add_index_resource;                     ProcVar: @@add_index_resource;                     Name: 'add_index_resource'),
  	(StubProc: @ZendStub_add_index_double;                       ProcVar: @@add_index_double;                       Name: 'add_index_double'),
  	(StubProc: @ZendStub_add_index_string;                       ProcVar: @@add_index_string;                       Name: 'add_index_string'),
  	(StubProc: @ZendStub_add_index_stringl;                      ProcVar: @@add_index_stringl;                      Name: 'add_index_stringl'),
  	(StubProc: @ZendStub_add_index_zval;                         ProcVar: @@add_index_zval;                         Name: 'add_index_zval'),
  	(StubProc: @ZendStub_add_next_index_long;                    ProcVar: @@add_next_index_long;                    Name: 'add_next_index_long'),
  	(StubProc: @ZendStub_add_next_index_null;                    ProcVar: @@add_next_index_null;                    Name: 'add_next_index_null'),
  	(StubProc: @ZendStub_add_next_index_bool;                    ProcVar: @@add_next_index_bool;                    Name: 'add_next_index_bool'),
  	(StubProc: @ZendStub_add_next_index_resource;                ProcVar: @@add_next_index_resource;                Name: 'add_next_index_resource'),
  	(StubProc: @ZendStub_add_next_index_double;                  ProcVar: @@add_next_index_double;                  Name: 'add_next_index_double'),
  	(StubProc: @ZendStub_add_next_index_string;                  ProcVar: @@add_next_index_string;                  Name: 'add_next_index_string'),
  	(StubProc: @ZendStub_add_next_index_stringl;                 ProcVar: @@add_next_index_stringl;                 Name: 'add_next_index_stringl'),
  	(StubProc: @ZendStub_add_next_index_zval;                    ProcVar: @@add_next_index_zval;                    Name: 'add_next_index_zval'),
  	(StubProc: @ZendStub_add_get_assoc_string_ex;                ProcVar: @@add_get_assoc_string_ex;                Name: 'add_get_assoc_string_ex'),
  	(StubProc: @ZendStub_add_get_assoc_stringl_ex;               ProcVar: @@add_get_assoc_stringl_ex;               Name: 'add_get_assoc_stringl_ex'),
  	(StubProc: @ZendStub_add_get_index_long;                     ProcVar: @@add_get_index_long;                     Name: 'add_get_index_long'),
  	(StubProc: @ZendStub_add_get_index_double;                   ProcVar: @@add_get_index_double;                   Name: 'add_get_index_double'),
  	(StubProc: @ZendStub_add_get_index_string;                   ProcVar: @@add_get_index_string;                   Name: 'add_get_index_string'),
  	(StubProc: @ZendStub_add_get_index_stringl;                  ProcVar: @@add_get_index_stringl;                  Name: 'add_get_index_stringl'),
  	(StubProc: @ZendStub__array_init;                            ProcVar: @@_array_init;                            Name: '_array_init'),
  	(StubProc: @ZendStub__object_init;                           ProcVar: @@_object_init;                           Name: '_object_init'),
  	(StubProc: @ZendStub__object_init_ex;                        ProcVar: @@_object_init_ex;                        Name: '_object_init_ex'),
  	(StubProc: @ZendStub__object_and_properties_init;            ProcVar: @@_object_and_properties_init;            Name: '_object_and_properties_init'),
  	(StubProc: @ZendStub_zend_register_internal_class;           ProcVar: @@zend_register_internal_class;           Name: 'zend_register_internal_class'),
  	(StubProc: @ZendStub_zend_register_internal_class_ex;        ProcVar: @@zend_register_internal_class_ex;        Name: 'zend_register_internal_class_ex'),
  	(StubProc: @ZendStub_get_zend_version;                       ProcVar: @@get_zend_version;                       Name: 'get_zend_version'),
  	(StubProc: @ZendStub_zend_make_printable_zval;               ProcVar: @@zend_make_printable_zval;               Name: 'zend_make_printable_zval'),
  	(StubProc: @ZendStub_zend_print_zval;                        ProcVar: @@zend_print_zval;                        Name: 'zend_print_zval'),
  	(StubProc: @ZendStub_zend_print_zval_r;                      ProcVar: @@zend_print_zval_r;                      Name: 'zend_print_zval_r'),
  	(StubProc: @ZendStub_zend_output_debug_string;               ProcVar: @@zend_output_debug_string;               Name: 'zend_output_debug_string'),
  	(StubProc: @ZendStub_ZendGetParameters;                      ProcVar: @@ZendGetParameters;                      Name: 'zend_get_parameters'));



function ZendCall( AStubEntryIndex : DWORD ) : Pointer;
begin
  with ZendStubTable[AStubEntryIndex] do
  begin
    if PHPLib = 0 then
    begin
      raise Exception.Create('php4ts.dll not loaded');
    end;
    Result := Windows.GetProcAddress( phpLib, Name );
    if Result = nil then
      raise EPHP4DelphiException(Name);
      
    ProcVar^ := Result;
  end;
end;

procedure ZendStubInit;
var i : Integer;
begin
  for i := 0 to ZendStubEntryCount-1 do
    with ZendStubTable[i] do
      ProcVar^ := StubProc;
end;

procedure LoadZEND(const DllFilename: string);
var
  WriteFuncPtr                                    : pointer;
begin
  PHPLib := LoadLibrary(PChar(DllFilename));
{$IFNDEF QUET_LOAD}
  if PHPLib = 0 then raise Exception.Create('php4ts.dll not found');
{$ELSE}
  if PHPLib = 0 then Exit;
{$ENDIF}

  zend_ini_deactivate := GetProcAddress(PHPLib, 'zend_ini_deactivate');

  // -- tsrm_startup
  tsrm_startup := GetProcAddress(PHPLib, 'tsrm_startup');

  // -- ts_allocate_id
  ts_allocate_id := GetProcAddress(PHPLib, 'ts_allocate_id');

  // -- ts_free_id
  ts_free_id := GetProcAddress(PHPLib, 'ts_free_id');


  // -- zend_strndup
  zend_strndup := GetProcAddress(PHPLib, 'zend_strndup');


  // -- _emalloc
  _emalloc := GetProcAddress(PHPLib, '_emalloc');


  // -- _efree
  _efree := GetProcAddress(PHPLib, '_efree');


  // -- _ecalloc
  _ecalloc := GetProcAddress(PHPLib, '_ecalloc');


  // -- _erealloc
  _erealloc := GetProcAddress(PHPLib, '_erealloc');


  // -- _estrdup
  _estrdup := GetProcAddress(PHPLib, '_estrdup');

  // -- _estrndup
  _estrndup := GetProcAddress(PHPLib, '_estrndup');

  // -- zend_set_memory_limit
  zend_set_memory_limit := GetProcAddress(PHPLib, 'zend_set_memory_limit');

  // -- start_memory_manager
  start_memory_manager := GetProcAddress(PHPLib, 'start_memory_manager');

  // -- shutdown_memory_manager
  shutdown_memory_manager := GetProcAddress(PHPLib, 'shutdown_memory_manager');

  // -- zend_hash_init
  zend_hash_init := GetProcAddress(PHPLib, 'zend_hash_init');

  // -- zend_hash_init_ex
  zend_hash_init_ex := GetProcAddress(PHPLib, 'zend_hash_init_ex');

  // -- zend_hash_destroy
  zend_hash_destroy := GetProcAddress(PHPLib, 'zend_hash_destroy');

  // -- zend_hash_clean
  zend_hash_clean := GetProcAddress(PHPLib, 'zend_hash_clean');

  // -- zend_hash_add_or_update
  zend_hash_add_or_update := GetProcAddress(PHPLib, 'zend_hash_add_or_update');

  // -- zend_hash_quick_add_or_update
  zend_hash_quick_add_or_update := GetProcAddress(PHPLib, 'zend_hash_quick_add_or_update');

  // -- zend_hash_index_update_or_next_insert
  zend_hash_index_update_or_next_insert := GetProcAddress(PHPLib, 'zend_hash_index_update_or_next_insert');

  // -- zend_hash_add_empty_element
  zend_hash_add_empty_element := GetProcAddress(PHPLib, 'zend_hash_add_empty_element');

  // -- zend_hash_graceful_destroy
  zend_hash_graceful_destroy := GetProcAddress(PHPLib, 'zend_hash_graceful_destroy');

  // -- zend_hash_graceful_reverse_destroy
  zend_hash_graceful_reverse_destroy := GetProcAddress(PHPLib, 'zend_hash_graceful_reverse_destroy');

  // -- zend_hash_apply
  zend_hash_apply := GetProcAddress(PHPLib, 'zend_hash_apply');

  // -- zend_hash_apply_with_argument
  zend_hash_apply_with_argument := GetProcAddress(PHPLib, 'zend_hash_apply_with_argument');

  // -- zend_hash_reverse_apply
  zend_hash_reverse_apply := GetProcAddress(PHPLib, 'zend_hash_reverse_apply');

  // -- zend_hash_del_key_or_index
  zend_hash_del_key_or_index := GetProcAddress(PHPLib, 'zend_hash_del_key_or_index');

  // -- zend_get_hash_value
  zend_get_hash_value := GetProcAddress(PHPLib, 'zend_get_hash_value');

  // -- zend_hash_find
  zend_hash_find := GetProcAddress(PHPLib, 'zend_hash_find');

  // -- zend_hash_quick_find
  zend_hash_quick_find := GetProcAddress(PHPLib, 'zend_hash_quick_find');

  // -- zend_hash_index_find
  zend_hash_index_find := GetProcAddress(PHPLib, 'zend_hash_index_find');

  // -- zend_hash_exists
  zend_hash_exists := GetProcAddress(PHPLib, 'zend_hash_exists');

  // -- zend_hash_index_exists
  zend_hash_index_exists := GetProcAddress(PHPLib, 'zend_hash_index_exists');

  // -- zend_hash_next_free_element
  zend_hash_next_free_element := GetProcAddress(PHPLib, 'zend_hash_next_free_element');

  // -- zend_hash_move_forward_ex
  zend_hash_move_forward_ex := GetProcAddress(PHPLib, 'zend_hash_move_forward_ex');

  // -- zend_hash_move_backwards_ex
  zend_hash_move_backwards_ex := GetProcAddress(PHPLib, 'zend_hash_move_backwards_ex');

  // -- zend_hash_get_current_key_ex
  zend_hash_get_current_key_ex := GetProcAddress(PHPLib, 'zend_hash_get_current_key_ex');

  // -- zend_hash_get_current_key_type_ex
  zend_hash_get_current_key_type_ex := GetProcAddress(PHPLib, 'zend_hash_get_current_key_type_ex');

  // -- zend_hash_get_current_data_ex
  zend_hash_get_current_data_ex := GetProcAddress(PHPLib, 'zend_hash_get_current_data_ex');

  // -- zend_hash_internal_pointer_reset_ex
  zend_hash_internal_pointer_reset_ex := GetProcAddress(PHPLib, 'zend_hash_internal_pointer_reset_ex');

  // -- zend_hash_internal_pointer_end_ex
  zend_hash_internal_pointer_end_ex := GetProcAddress(PHPLib, 'zend_hash_internal_pointer_end_ex');

  // -- zend_hash_copy
  zend_hash_copy := GetProcAddress(PHPLib, 'zend_hash_copy');

  // -- zend_hash_merge
  zend_hash_merge := GetProcAddress(PHPLib, 'zend_hash_merge');

  // -- zend_hash_sort
  zend_hash_sort := GetProcAddress(PHPLib, 'zend_hash_sort');

  // -- zend_hash_compare
  zend_hash_compare := GetProcAddress(PHPLib, 'zend_hash_compare');

  // -- zend_hash_minmax
  zend_hash_minmax := GetProcAddress(PHPLib, 'zend_hash_minmax');

  // -- zend_hash_num_elements
  zend_hash_num_elements := GetProcAddress(PHPLib, 'zend_hash_num_elements');

  // -- zend_hash_rehash
  zend_hash_rehash := GetProcAddress(PHPLib, 'zend_hash_rehash');

  // -- zend_hash_func
  zend_hash_func := GetProcAddress(PHPLib, 'zend_hash_func');

  // -- zend_get_constant
  zend_get_constant := GetProcAddress(PHPLib, 'zend_get_constant');

  // -- zend_register_long_constant
  zend_register_long_constant := GetProcAddress(PHPLib, 'zend_register_long_constant');

  // -- zend_register_double_constant
  zend_register_double_constant := GetProcAddress(PHPLib, 'zend_register_double_constant');

  // -- zend_register_string_constant
  zend_register_string_constant := GetProcAddress(PHPLib, 'zend_register_string_constant');

  // -- zend_register_stringl_constant
  zend_register_stringl_constant := GetProcAddress(PHPLib, 'zend_register_stringl_constant');

  // -- zend_register_constant
  zend_register_constant := GetProcAddress(PHPLib, 'zend_register_constant');

  // -- tsrm_shutdown
  tsrm_shutdown := GetProcAddress(PHPLib, 'tsrm_shutdown');

  // -- ts_resource_ex
  ts_resource_ex := GetProcAddress(PHPLib, 'ts_resource_ex');

  // -- ts_free_thread
  ts_free_thread := GetProcAddress(PHPLib, 'ts_free_thread');

  // -- zend_error
  zend_error := GetProcAddress(PHPLib, 'zend_error');

  // -- zend_error_cb
  zend_error_cb := GetProcAddress(PHPLib, 'zend_error_cb');

  // -- zend_eval_string
  zend_eval_string := GetProcAddress(PHPLib, 'zend_eval_string');

  // -- zend_make_compiled_string_description
  zend_make_compiled_string_description := GetProcAddress(PHPLib, 'zend_make_compiled_string_description');

  // -- _zval_dtor
  _zval_dtor := GetProcAddress(PHPLib, '_zval_dtor');

  // -- _zval_copy_ctor
  _zval_copy_ctor := GetProcAddress(PHPLib, '_zval_copy_ctor');

  // -- zend_print_variable
  zend_print_variable := GetProcAddress(PHPLib, 'zend_print_variable');

  // -- zend_stack_init
  zend_stack_init := GetProcAddress(PHPLib, 'zend_stack_init');

  // -- zend_stack_push
  zend_stack_push := GetProcAddress(PHPLib, 'zend_stack_push');

  // -- zend_stack_top
  zend_stack_top := GetProcAddress(PHPLib, 'zend_stack_top');

  // -- zend_stack_del_top
  zend_stack_del_top := GetProcAddress(PHPLib, 'zend_stack_del_top');

  // -- zend_stack_int_top
  zend_stack_int_top := GetProcAddress(PHPLib, 'zend_stack_int_top');

  // -- zend_stack_is_empty
  zend_stack_is_empty := GetProcAddress(PHPLib, 'zend_stack_is_empty');

  // -- zend_stack_destroy
  zend_stack_destroy := GetProcAddress(PHPLib, 'zend_stack_destroy');

  // -- zend_stack_base
  zend_stack_base := GetProcAddress(PHPLib, 'zend_stack_base');

  // -- zend_stack_count
  zend_stack_count := GetProcAddress(PHPLib, 'zend_stack_count');

  // -- zend_stack_apply
  zend_stack_apply := GetProcAddress(PHPLib, 'zend_stack_apply');

  // -- zend_stack_apply_with_argument
  zend_stack_apply_with_argument := GetProcAddress(PHPLib, 'zend_stack_apply_with_argument');

  // -- _convert_to_string
  _convert_to_string := GetProcAddress(PHPLib, '_convert_to_string');

  // -- add_function
  add_function := GetProcAddress(PHPLib, 'add_function');

  // -- sub_function
  sub_function := GetProcAddress(PHPLib, 'sub_function');

  // -- mul_function
  mul_function := GetProcAddress(PHPLib, 'mul_function');

  // -- div_function
  div_function := GetProcAddress(PHPLib, 'div_function');

  // -- mod_function
  mod_function := GetProcAddress(PHPLib, 'mod_function');

  // -- boolean_xor_function
  boolean_xor_function := GetProcAddress(PHPLib, 'boolean_xor_function');

  // -- boolean_not_function
  boolean_not_function := GetProcAddress(PHPLib, 'boolean_not_function');

  // -- bitwise_not_function
  bitwise_not_function := GetProcAddress(PHPLib, 'bitwise_not_function');

  // -- bitwise_or_function
  bitwise_or_function := GetProcAddress(PHPLib, 'bitwise_or_function');

  // -- bitwise_and_function
  bitwise_and_function := GetProcAddress(PHPLib, 'bitwise_and_function');

  // -- bitwise_xor_function
  bitwise_xor_function := GetProcAddress(PHPLib, 'bitwise_xor_function');

  // -- shift_left_function
  shift_left_function := GetProcAddress(PHPLib, 'shift_left_function');

  // -- shift_right_function
  shift_right_function := GetProcAddress(PHPLib, 'shift_right_function');

  // -- concat_function
  concat_function := GetProcAddress(PHPLib, 'concat_function');

  // -- is_equal_function
  is_equal_function := GetProcAddress(PHPLib, 'is_equal_function');

  // -- is_identical_function
  is_identical_function := GetProcAddress(PHPLib, 'is_identical_function');

  // -- is_not_identical_function
  is_not_identical_function := GetProcAddress(PHPLib, 'is_not_identical_function');

  // -- is_not_equal_function
  is_not_equal_function := GetProcAddress(PHPLib, 'is_not_equal_function');

  // -- is_smaller_function
  is_smaller_function := GetProcAddress(PHPLib, 'is_smaller_function');

  // -- is_smaller_or_equal_function
  is_smaller_or_equal_function := GetProcAddress(PHPLib, 'is_smaller_or_equal_function');

  // -- increment_function
  increment_function := GetProcAddress(PHPLib, 'increment_function');

  // -- decrement_function
  decrement_function := GetProcAddress(PHPLib, 'decrement_function');

  // -- convert_scalar_to_number
  convert_scalar_to_number := GetProcAddress(PHPLib, 'convert_scalar_to_number');

  // -- convert_to_long
  convert_to_long := GetProcAddress(PHPLib, 'convert_to_long');

  // -- convert_to_double
  convert_to_double := GetProcAddress(PHPLib, 'convert_to_double');

  // -- convert_to_long_base
  convert_to_long_base := GetProcAddress(PHPLib, 'convert_to_long_base');

  // -- convert_to_null
  convert_to_null := GetProcAddress(PHPLib, 'convert_to_null');

  // -- convert_to_boolean
  convert_to_boolean := GetProcAddress(PHPLib, 'convert_to_boolean');

  // -- convert_to_array
  convert_to_array := GetProcAddress(PHPLib, 'convert_to_array');

  // -- convert_to_object
  convert_to_object := GetProcAddress(PHPLib, 'convert_to_object');

  // -- add_char_to_string
  add_char_to_string := GetProcAddress(PHPLib, 'add_char_to_string');

  // -- add_string_to_string
  add_string_to_string := GetProcAddress(PHPLib, 'add_string_to_string');

  // -- zend_string_to_double
  zend_string_to_double := GetProcAddress(PHPLib, 'zend_string_to_double');

  // -- zval_is_true
  zval_is_true := GetProcAddress(PHPLib, 'zval_is_true');

  // -- compare_function
  compare_function := GetProcAddress(PHPLib, 'compare_function');

  // -- numeric_compare_function
  numeric_compare_function := GetProcAddress(PHPLib, 'numeric_compare_function');

  // -- string_compare_function
  string_compare_function := GetProcAddress(PHPLib, 'string_compare_function');

  // -- zend_str_tolower
  zend_str_tolower := GetProcAddress(PHPLib, 'zend_str_tolower');

  // -- zend_binary_zval_strcmp
  zend_binary_zval_strcmp := GetProcAddress(PHPLib, 'zend_binary_zval_strcmp');

  // -- zend_binary_zval_strncmp
  zend_binary_zval_strncmp := GetProcAddress(PHPLib, 'zend_binary_zval_strncmp');

  // -- zend_binary_zval_strcasecmp
  zend_binary_zval_strcasecmp := GetProcAddress(PHPLib, 'zend_binary_zval_strcasecmp');

  // -- zend_binary_zval_strncasecmp
  zend_binary_zval_strncasecmp := GetProcAddress(PHPLib, 'zend_binary_zval_strncasecmp');

  // -- zend_binary_strcmp
  zend_binary_strcmp := GetProcAddress(PHPLib, 'zend_binary_strcmp');

  // -- zend_binary_strncmp
  zend_binary_strncmp := GetProcAddress(PHPLib, 'zend_binary_strncmp');

  // -- zend_binary_strcasecmp
  zend_binary_strcasecmp := GetProcAddress(PHPLib, 'zend_binary_strcasecmp');

  // -- zend_binary_strncasecmp
  zend_binary_strncasecmp := GetProcAddress(PHPLib, 'zend_binary_strncasecmp');

  // -- zendi_smart_strcmp
  zendi_smart_strcmp := GetProcAddress(PHPLib, 'zendi_smart_strcmp');

  // -- zend_compare_symbol_tables
  zend_compare_symbol_tables := GetProcAddress(PHPLib, 'zend_compare_symbol_tables');

  // -- zend_compare_arrays
  zend_compare_arrays := GetProcAddress(PHPLib, 'zend_compare_arrays');

  // -- zend_compare_objects
  zend_compare_objects := GetProcAddress(PHPLib, 'zend_compare_objects');

  // -- zend_atoi
  zend_atoi := GetProcAddress(PHPLib, 'zend_atoi');

  // -- get_active_function_name
  get_active_function_name := GetProcAddress(PHPLib, 'get_active_function_name');

  // -- zend_get_executed_filename
  zend_get_executed_filename := GetProcAddress(PHPLib, 'zend_get_executed_filename');

  // -- zend_set_timeout
  zend_set_timeout := GetProcAddress(PHPLib, 'zend_set_timeout');

  // -- zend_unset_timeout
  zend_unset_timeout := GetProcAddress(PHPLib, 'zend_unset_timeout');

  // -- zend_timeout
  zend_timeout := GetProcAddress(PHPLib, 'zend_timeout');

  // -- zend_highlight
  zend_highlight := GetProcAddress(PHPLib, 'zend_highlight');

  // -- zend_strip
  zend_strip := GetProcAddress(PHPLib, 'zend_strip');

  // -- highlight_file
  highlight_file := GetProcAddress(PHPLib, 'highlight_file');

  // -- highlight_string
  highlight_string := GetProcAddress(PHPLib, 'highlight_string');

  // -- zend_html_putc
  zend_html_putc := GetProcAddress(PHPLib, 'zend_html_putc');

  // -- zend_html_puts
  zend_html_puts := GetProcAddress(PHPLib, 'zend_html_puts');

  // -- zend_indent
  zend_indent := GetProcAddress(PHPLib, 'zend_indent');

  // -- _zend_get_parameters_array_ex
  _zend_get_parameters_array_ex := GetProcAddress(PHPLib, '_zend_get_parameters_array_ex');

  // -- zend_ini_refresh_caches
  zend_ini_refresh_caches := GetProcAddress(PHPLib, 'zend_ini_refresh_caches');

  // -- zend_alter_ini_entry
  zend_alter_ini_entry := GetProcAddress(PHPLib, 'zend_alter_ini_entry');

  // -- zend_restore_ini_entry
  zend_restore_ini_entry := GetProcAddress(PHPLib, 'zend_restore_ini_entry');

  // -- zend_ini_long
  zend_ini_long := GetProcAddress(PHPLib, 'zend_ini_long');

  // -- zend_ini_double
  zend_ini_double := GetProcAddress(PHPLib, 'zend_ini_double');

  // -- zend_ini_string
  zend_ini_string := GetProcAddress(PHPLib, 'zend_ini_string');

  // -- compile_string
  compile_string := GetProcAddress(PHPLib, 'compile_string');

  // -- execute
  execute := GetProcAddress(PHPLib, 'execute');

  // -- zend_wrong_param_count
  zend_wrong_param_count := GetProcAddress(PHPLib, 'zend_wrong_param_count');

  // -- add_property_long_ex
  add_property_long_ex := GetProcAddress(PHPLib, 'add_property_long_ex');

  // -- add_property_null_ex
  add_property_null_ex := GetProcAddress(PHPLib, 'add_property_null_ex');

  // -- add_property_bool_ex
  add_property_bool_ex := GetProcAddress(PHPLib, 'add_property_bool_ex');

  // -- add_property_resource_ex
  add_property_resource_ex := GetProcAddress(PHPLib, 'add_property_resource_ex');

  // -- add_property_double_ex
  add_property_double_ex := GetProcAddress(PHPLib, 'add_property_double_ex');

  // -- add_property_string_ex
  add_property_string_ex := GetProcAddress(PHPLib, 'add_property_string_ex');

  // -- add_property_stringl_ex
  add_property_stringl_ex := GetProcAddress(PHPLib, 'add_property_stringl_ex');

  // -- add_property_zval_ex
  add_property_zval_ex := GetProcAddress(PHPLib, 'add_property_zval_ex');

  // -- add_assoc_long_ex
  add_assoc_long_ex := GetProcAddress(PHPLib, 'add_assoc_long_ex');

  // -- add_assoc_null_ex
  add_assoc_null_ex := GetProcAddress(PHPLib, 'add_assoc_null_ex');

  // -- add_assoc_bool_ex
  add_assoc_bool_ex := GetProcAddress(PHPLib, 'add_assoc_bool_ex');

  // -- add_assoc_resource_ex
  add_assoc_resource_ex := GetProcAddress(PHPLib, 'add_assoc_resource_ex');

  // -- add_assoc_double_ex
  add_assoc_double_ex := GetProcAddress(PHPLib, 'add_assoc_double_ex');

  // -- add_assoc_string_ex
  add_assoc_string_ex := GetProcAddress(PHPLib, 'add_assoc_string_ex');

  // -- add_assoc_stringl_ex
  add_assoc_stringl_ex := GetProcAddress(PHPLib, 'add_assoc_stringl_ex');

  // -- add_assoc_zval_ex
  add_assoc_zval_ex := GetProcAddress(PHPLib, 'add_assoc_zval_ex');

  // -- add_index_long
  add_index_long := GetProcAddress(PHPLib, 'add_index_long');

  // -- add_index_null
  add_index_null := GetProcAddress(PHPLib, 'add_index_null');

  // -- add_index_bool
  add_index_bool := GetProcAddress(PHPLib, 'add_index_bool');

  // -- add_index_resource
  add_index_resource := GetProcAddress(PHPLib, 'add_index_resource');

  // -- add_index_double
  add_index_double := GetProcAddress(PHPLib, 'add_index_double');

  // -- add_index_string
  add_index_string := GetProcAddress(PHPLib, 'add_index_string');

  // -- add_index_stringl
  add_index_stringl := GetProcAddress(PHPLib, 'add_index_stringl');

  // -- add_index_zval
  add_index_zval := GetProcAddress(PHPLib, 'add_index_zval');

  // -- add_next_index_long
  add_next_index_long := GetProcAddress(PHPLib, 'add_next_index_long');

  // -- add_next_index_null
  add_next_index_null := GetProcAddress(PHPLib, 'add_next_index_null');

  // -- add_next_index_bool
  add_next_index_bool := GetProcAddress(PHPLib, 'add_next_index_bool');

  // -- add_next_index_resource
  add_next_index_resource := GetProcAddress(PHPLib, 'add_next_index_resource');

  // -- add_next_index_double
  add_next_index_double := GetProcAddress(PHPLib, 'add_next_index_double');

  // -- add_next_index_string
  add_next_index_string := GetProcAddress(PHPLib, 'add_next_index_string');

  // -- add_next_index_stringl
  add_next_index_stringl := GetProcAddress(PHPLib, 'add_next_index_stringl');

  // -- add_next_index_zval
  add_next_index_zval := GetProcAddress(PHPLib, 'add_next_index_zval');

  // -- add_get_assoc_string_ex
  add_get_assoc_string_ex := GetProcAddress(PHPLib, 'add_get_assoc_string_ex');

  // -- add_get_assoc_stringl_ex
  add_get_assoc_stringl_ex := GetProcAddress(PHPLib, 'add_get_assoc_stringl_ex');

  // -- add_get_index_long
  add_get_index_long := GetProcAddress(PHPLib, 'add_get_index_long');

  // -- add_get_index_double
  add_get_index_double := GetProcAddress(PHPLib, 'add_get_index_double');

  // -- add_get_index_string
  add_get_index_string := GetProcAddress(PHPLib, 'add_get_index_string');

  // -- add_get_index_stringl
  add_get_index_stringl := GetProcAddress(PHPLib, 'add_get_index_stringl');

  // -- _array_init
  _array_init := GetProcAddress(PHPLib, '_array_init');

  // -- _object_init
  _object_init := GetProcAddress(PHPLib, '_object_init');

  // -- _object_init_ex
  _object_init_ex := GetProcAddress(PHPLib, '_object_init_ex');

  // -- _object_and_properties_init
  _object_and_properties_init := GetProcAddress(PHPLib, '_object_and_properties_init');

    // -- zend_register_internal_class
  zend_register_internal_class := GetProcAddress(PHPLib, 'zend_register_internal_class');

  // -- zend_register_internal_class_ex
  zend_register_internal_class_ex := GetProcAddress(PHPLib, 'zend_register_internal_class_ex');

  // -- get_zend_version
  get_zend_version := GetProcAddress(PHPLib, 'get_zend_version');

  // -- zend_make_printable_zval
  zend_make_printable_zval := GetProcAddress(PHPLib, 'zend_make_printable_zval');

  // -- zend_print_zval
  zend_print_zval := GetProcAddress(PHPLib, 'zend_print_zval');

  // -- zend_print_zval_r
  zend_print_zval_r := GetProcAddress(PHPLib, 'zend_print_zval_r');

  // -- zend_output_debug_string
  zend_output_debug_string := GetProcAddress(PHPLib, 'zend_output_debug_string');

  // -- zend_get_parameters
  ZendGetParameters := GetProcAddress(PHPLib, 'zend_get_parameters');

 {$IFNDEF QUET_LOAD}
 CheckZendErrors;
 {$ENDIF}
 
  WriteFuncPtr := GetProcAddress(PHPLib, 'zend_write');
  if Assigned(WriteFuncPtr) then
    @zend_write := pointer(WriteFuncPtr^);
end;

procedure ZEND_PUTS(str: PChar);
begin
  zend_write(str, strlen(str));
end;

procedure convert_to_string(op: pzval);
begin
  _convert_to_string(op, nil, 0);
end;

procedure INIT_CLASS_ENTRY(var class_container: Tzend_class_entry; class_name: pchar; functions: pointer);
begin
  class_container.name := estrdup(class_name);
  class_container.name_length := strlen(class_name);
  class_container.builtin_functions := functions;
  class_container.handle_function_call := nil;
  class_container.handle_property_get := nil;
  class_container.handle_property_set := nil;
end;

function ZEND_FAST_ALLOC: pzval;
begin
  Result := emalloc(sizeof(zval));
end;

function ALLOC_ZVAL: pzval;
begin
  Result := emalloc(sizeof(zval));
end;

procedure INIT_PZVAL(p: pzval);
begin
  p^.refcount := 1;
  p^.is_ref := 0;
end;

function MAKE_STD_ZVAL: pzval;
begin
  Result := ALLOC_ZVAL;
  INIT_PZVAL(Result);
end;

function zend_get_parameters_ex(number: integer; var Params: pzval_array): integer;
var
  i                                               : integer;
begin
  SetLength(Params, number);
  if number = 0 then begin
    Result := SUCCESS;
    Exit;
  end;
  for i := 0 to number - 1 do
    New(Params[i]);
  Result := zend_get_parameters(number, number, Params);
end;

function zend_get_parameters(ht: integer; param_count: integer; Params: array of ppzval): integer; assembler; register;
asm
  push  esi
  mov   esi, ecx
  mov   ecx, [ebp+8]
  cmp   ecx, 0
  je @first
  @toploop:
  {$IFDEF VERSION6}
  push  [esi][ecx * 4]
  {$ELSE}
  push  dword [esi][ecx * 4]
  {$ENDIF}
  loop   @toploop
  @first:
  push    dword [esi]
  push    edx
  push    eax
  call    ZendGetParameters
  mov   ecx, [ebp+8]
  add     ecx, 3
  @toploop2:
  pop     edx
  loop   @toploop2
  pop     esi
end;

procedure dispose_pzval_array(Params: pzval_array);
var
  i                                               : integer;
begin
  for i := 0 to High(Params) do
    FreeMem(Params[i]);
end;

{ EPHP4DelphiException }

constructor EPHP4DelphiException.Create(const Msg: string);
begin
  inherited Create('Unable to link '+ Msg+' function');
end;

procedure ReportLinkError(FunctionName : string);
begin
  MessageDlg('Unable to link ' + FunctionName+ ' function', mtError, [mbOK], 0);
end;

procedure zenderror(Error : PChar);
begin
  zend_error(E_PARSE, Error);
end;


procedure CheckZendErrors;
begin
  {$IFDEF LINK_EXCEPTION}
  if @tsrm_startup = nil then raise EPHP4DelphiException.Create('tsrm_startup');
  if @ts_allocate_id = nil then raise EPHP4DelphiException.Create('ts_allocate_id');
  if @ts_free_id = nil then raise EPHP4DelphiException.Create('ts_free_id');
  if @zend_strndup = nil then raise EPHP4DelphiException.Create('zend_strndup');
  if @_emalloc = nil then raise EPHP4DelphiException.Create('_emalloc');
  if @_efree = nil then raise EPHP4DelphiException.Create('_efree');
  if @_ecalloc = nil then raise EPHP4DelphiException.Create('_ecalloc');
  if @_erealloc = nil then raise EPHP4DelphiException.Create('_erealloc');
  if @_estrdup = nil then raise EPHP4DelphiException.Create('_estrdup');
  if @_estrndup = nil then raise EPHP4DelphiException.Create('_estrndup');
  if @zend_set_memory_limit = nil then raise EPHP4DelphiException.Create('zend_set_memory_limit');
  if @start_memory_manager = nil then raise EPHP4DelphiException.Create('start_memory_manager');
  if @shutdown_memory_manager = nil then raise EPHP4DelphiException.Create('shutdown_memory_manager');
  if @zend_hash_init = nil then raise EPHP4DelphiException.Create('zend_hash_init');
  if @zend_hash_init_ex = nil then raise EPHP4DelphiException.Create('zend_hash_init_ex');
  if @zend_hash_destroy = nil then raise EPHP4DelphiException.Create('zend_hash_destroy');
  if @zend_hash_clean = nil then raise EPHP4DelphiException.Create('zend_hash_clean');
  if @zend_hash_add_or_update = nil then raise EPHP4DelphiException.Create('zend_hash_add_or_update');
  if @zend_hash_quick_add_or_update = nil then raise EPHP4DelphiException.Create('zend_hash_quick_add_or_update');
  if @zend_hash_index_update_or_next_insert = nil then raise EPHP4DelphiException.Create('zend_hash_index_update_or_next_insert');
  if @zend_hash_add_empty_element = nil then raise EPHP4DelphiException.Create('zend_hash_add_empty_element');
  if @zend_hash_graceful_destroy = nil then raise EPHP4DelphiException.Create('zend_hash_graceful_destroy');
  if @zend_hash_graceful_reverse_destroy = nil then raise EPHP4DelphiException.Create('zend_hash_graceful_reverse_destroy');
  if @zend_hash_apply = nil then raise EPHP4DelphiException.Create('zend_hash_apply');
  if @zend_hash_apply_with_argument = nil then raise EPHP4DelphiException.Create('zend_hash_apply_with_argument');
  if @zend_hash_reverse_apply = nil then raise EPHP4DelphiException.Create('zend_hash_reverse_apply');
  if @zend_hash_del_key_or_index = nil then raise EPHP4DelphiException.Create('zend_hash_del_key_or_index');
  if @zend_get_hash_value = nil then raise EPHP4DelphiException.Create('zend_get_hash_value');
  if @zend_hash_find = nil then raise EPHP4DelphiException.Create('zend_hash_find');
  if @zend_hash_quick_find = nil then raise EPHP4DelphiException.Create('zend_hash_quick_find');
  if @zend_hash_index_find = nil then raise EPHP4DelphiException.Create('zend_hash_index_find');
  if @zend_hash_exists = nil then raise EPHP4DelphiException.Create('zend_hash_exists');
  if @zend_hash_index_exists = nil then raise EPHP4DelphiException.Create('zend_hash_index_exists');
  if @zend_hash_next_free_element = nil then raise EPHP4DelphiException.Create('zend_hash_next_free_element');
  if @zend_hash_move_forward_ex = nil then raise EPHP4DelphiException.Create('zend_hash_move_forward_ex');
  if @zend_hash_move_backwards_ex = nil then raise EPHP4DelphiException.Create('zend_hash_move_backwards_ex');
  if @zend_hash_get_current_key_ex = nil then raise EPHP4DelphiException.Create('zend_hash_get_current_key_ex');
  if @zend_hash_get_current_key_type_ex = nil then raise EPHP4DelphiException.Create('zend_hash_get_current_key_type_ex');
  if @zend_hash_get_current_data_ex = nil then raise EPHP4DelphiException.Create('zend_hash_get_current_data_ex');
  if @zend_hash_internal_pointer_reset_ex = nil then raise EPHP4DelphiException.Create('zend_hash_internal_pointer_reset_ex');
  if @zend_hash_internal_pointer_end_ex = nil then raise EPHP4DelphiException.Create('zend_hash_internal_pointer_end_ex');
  if @zend_hash_copy = nil then raise EPHP4DelphiException.Create('zend_hash_copy');
  if @zend_hash_merge = nil then raise EPHP4DelphiException.Create('zend_hash_merge');
  if @zend_hash_sort = nil then raise EPHP4DelphiException.Create('zend_hash_sort');
  if @zend_hash_compare = nil then raise EPHP4DelphiException.Create('zend_hash_compare');
  if @zend_hash_minmax = nil then raise EPHP4DelphiException.Create('zend_hash_minmax');
  if @zend_hash_num_elements = nil then raise EPHP4DelphiException.Create('zend_hash_num_elements');
  if @zend_hash_rehash = nil then raise EPHP4DelphiException.Create('zend_hash_rehash');
  if @zend_hash_func = nil then raise EPHP4DelphiException.Create('zend_hash_func');
  if @zend_get_constant = nil then raise EPHP4DelphiException.Create('zend_get_constant');
  if @zend_register_long_constant = nil then raise EPHP4DelphiException.Create('zend_register_long_constant');
  if @zend_register_double_constant = nil then raise EPHP4DelphiException.Create('zend_register_double_constant');
  if @zend_register_string_constant = nil then raise EPHP4DelphiException.Create('zend_register_string_constant');
  if @zend_register_stringl_constant = nil then raise EPHP4DelphiException.Create('zend_register_stringl_constant');
  if @zend_register_constant = nil then raise EPHP4DelphiException.Create('zend_register_constant');
  if @tsrm_shutdown = nil then raise EPHP4DelphiException.Create('tsrm_shutdown');
  if @ts_resource_ex = nil then raise EPHP4DelphiException.Create('ts_resource_ex');
  if @ts_free_thread = nil then raise EPHP4DelphiException.Create('ts_free_thread');
  if @zend_error = nil then raise EPHP4DelphiException.Create('zend_error');
  if @zend_error_cb = nil then raise EPHP4DelphiException.Create('zend_error_cb');
  if @zend_eval_string = nil then raise EPHP4DelphiException.Create('zend_eval_string');
  if @zend_make_compiled_string_description = nil then raise EPHP4DelphiException.Create('zend_make_compiled_string_description');
  if @_zval_dtor = nil then raise EPHP4DelphiException.Create('_zval_dtor');
  if @_zval_copy_ctor = nil then raise EPHP4DelphiException.Create('_zval_copy_ctor');
  if @zend_print_variable = nil then raise EPHP4DelphiException.Create('zend_print_variable');
  if @zend_stack_init = nil then raise EPHP4DelphiException.Create('zend_stack_init');
  if @zend_stack_push = nil then raise EPHP4DelphiException.Create('zend_stack_push');
  if @zend_stack_top = nil then raise EPHP4DelphiException.Create('zend_stack_top');
  if @zend_stack_del_top = nil then raise EPHP4DelphiException.Create('zend_stack_del_top');
  if @zend_stack_int_top = nil then raise EPHP4DelphiException.Create('zend_stack_int_top');
  if @zend_stack_is_empty = nil then raise EPHP4DelphiException.Create('zend_stack_is_empty');
  if @zend_stack_destroy = nil then raise EPHP4DelphiException.Create('zend_stack_destroy');
  if @zend_stack_base = nil then raise EPHP4DelphiException.Create('zend_stack_base');
  if @zend_stack_count = nil then raise EPHP4DelphiException.Create('zend_stack_count');
  if @zend_stack_apply = nil then raise EPHP4DelphiException.Create('zend_stack_apply');
  if @zend_stack_apply_with_argument = nil then raise EPHP4DelphiException.Create('zend_stack_apply_with_argument');
  if @_convert_to_string = nil then raise EPHP4DelphiException.Create('_convert_to_string');
  if @add_function = nil then raise EPHP4DelphiException.Create('add_function');
  if @sub_function = nil then raise EPHP4DelphiException.Create('sub_function');
  if @mul_function = nil then raise EPHP4DelphiException.Create('mul_function');
  if @div_function = nil then raise EPHP4DelphiException.Create('div_function');
  if @mod_function = nil then raise EPHP4DelphiException.Create('mod_function');
  if @boolean_xor_function = nil then raise EPHP4DelphiException.Create('boolean_xor_function');
  if @boolean_not_function = nil then raise EPHP4DelphiException.Create('boolean_not_function');
  if @bitwise_not_function = nil then raise EPHP4DelphiException.Create('bitwise_not_function');
  if @bitwise_or_function = nil then raise EPHP4DelphiException.Create('bitwise_or_function');
  if @bitwise_and_function = nil then raise EPHP4DelphiException.Create('bitwise_and_function');
  if @bitwise_xor_function = nil then raise EPHP4DelphiException.Create('bitwise_xor_function');
  if @shift_left_function = nil then raise EPHP4DelphiException.Create('shift_left_function');
  if @shift_right_function = nil then raise EPHP4DelphiException.Create('shift_right_function');
  if @concat_function = nil then raise EPHP4DelphiException.Create('concat_function');
  if @is_equal_function = nil then raise EPHP4DelphiException.Create('is_equal_function');
  if @is_identical_function = nil then raise EPHP4DelphiException.Create('is_identical_function');
  if @is_not_identical_function = nil then raise EPHP4DelphiException.Create('is_not_identical_function');
  if @is_not_equal_function = nil then raise EPHP4DelphiException.Create('is_not_equal_function');
  if @is_smaller_function = nil then raise EPHP4DelphiException.Create('is_smaller_function');
  if @is_smaller_or_equal_function = nil then raise EPHP4DelphiException.Create('is_smaller_or_equal_function');
  if @increment_function = nil then raise EPHP4DelphiException.Create('increment_function');
  if @decrement_function = nil then raise EPHP4DelphiException.Create('decrement_function');
  if @convert_scalar_to_number = nil then raise EPHP4DelphiException.Create('convert_scalar_to_number');
  if @convert_to_long = nil then raise EPHP4DelphiException.Create('convert_to_long');
  if @convert_to_double = nil then raise EPHP4DelphiException.Create('convert_to_double');
  if @convert_to_long_base = nil then raise EPHP4DelphiException.Create('convert_to_long_base');
  if @convert_to_null = nil then raise EPHP4DelphiException.Create('convert_to_null');
  if @convert_to_boolean = nil then raise EPHP4DelphiException.Create('convert_to_boolean');
  if @convert_to_array = nil then raise EPHP4DelphiException.Create('convert_to_array');
  if @convert_to_object = nil then raise EPHP4DelphiException.Create('convert_to_object');
  if @add_char_to_string = nil then raise EPHP4DelphiException.Create('add_char_to_string');
  if @add_string_to_string = nil then raise EPHP4DelphiException.Create('add_string_to_string');
  if @zend_string_to_double = nil then raise EPHP4DelphiException.Create('zend_string_to_double');
  if @zval_is_true = nil then raise EPHP4DelphiException.Create('zval_is_true');
  if @compare_function = nil then raise EPHP4DelphiException.Create('compare_function');
  if @numeric_compare_function = nil then raise EPHP4DelphiException.Create('numeric_compare_function');
  if @string_compare_function = nil then raise EPHP4DelphiException.Create('string_compare_function');
  if @zend_str_tolower = nil then raise EPHP4DelphiException.Create('zend_str_tolower');
  if @zend_binary_zval_strcmp = nil then raise EPHP4DelphiException.Create('zend_binary_zval_strcmp');
  if @zend_binary_zval_strncmp = nil then raise EPHP4DelphiException.Create('zend_binary_zval_strncmp');
  if @zend_binary_zval_strcasecmp = nil then raise EPHP4DelphiException.Create('zend_binary_zval_strcasecmp');
  if @zend_binary_zval_strncasecmp = nil then raise EPHP4DelphiException.Create('zend_binary_zval_strncasecmp');
  if @zend_binary_strcmp = nil then raise EPHP4DelphiException.Create('zend_binary_strcmp');
  if @zend_binary_strncmp = nil then raise EPHP4DelphiException.Create('zend_binary_strncmp');
  if @zend_binary_strcasecmp = nil then raise EPHP4DelphiException.Create('zend_binary_strcasecmp');
  if @zend_binary_strncasecmp = nil then raise EPHP4DelphiException.Create('zend_binary_strncasecmp');
  if @zendi_smart_strcmp = nil then raise EPHP4DelphiException.Create('zendi_smart_strcmp');
  if @zend_compare_symbol_tables = nil then raise EPHP4DelphiException.Create('zend_compare_symbol_tables');
  if @zend_compare_arrays = nil then raise EPHP4DelphiException.Create('zend_compare_arrays');
  if @zend_compare_objects = nil then raise EPHP4DelphiException.Create('zend_compare_objects');
  if @zend_atoi = nil then raise EPHP4DelphiException.Create('zend_atoi');
  if @get_active_function_name = nil then raise EPHP4DelphiException.Create('get_active_function_name');
  if @zend_get_executed_filename = nil then raise EPHP4DelphiException.Create('zend_get_executed_filename');
  if @zend_set_timeout = nil then raise EPHP4DelphiException.Create('zend_set_timeout');
  if @zend_unset_timeout = nil then raise EPHP4DelphiException.Create('zend_unset_timeout');
  if @zend_timeout = nil then raise EPHP4DelphiException.Create('zend_timeout');
  if @zend_highlight = nil then raise EPHP4DelphiException.Create('zend_highlight');
  if @zend_strip = nil then raise EPHP4DelphiException.Create('zend_strip');
  if @highlight_file = nil then raise EPHP4DelphiException.Create('highlight_file');
  if @highlight_string = nil then raise EPHP4DelphiException.Create('highlight_string');
  if @zend_html_putc = nil then raise EPHP4DelphiException.Create('zend_html_putc');
  if @zend_html_puts = nil then raise EPHP4DelphiException.Create('zend_html_puts');
  if @zend_indent = nil then raise EPHP4DelphiException.Create('zend_indent');
  if @_zend_get_parameters_array_ex = nil then raise EPHP4DelphiException.Create('_zend_get_parameters_array_ex');
  if @zend_ini_refresh_caches = nil then raise EPHP4DelphiException.Create('zend_ini_refresh_caches');
  if @zend_alter_ini_entry = nil then raise EPHP4DelphiException.Create('zend_alter_ini_entry');
  if @zend_restore_ini_entry = nil then raise EPHP4DelphiException.Create('zend_restore_ini_entry');
  if @zend_ini_long = nil then raise EPHP4DelphiException.Create('zend_ini_long');
  if @zend_ini_double = nil then raise EPHP4DelphiException.Create('zend_ini_double');
  if @zend_ini_string = nil then raise EPHP4DelphiException.Create('zend_ini_string');
  if @compile_string = nil then raise EPHP4DelphiException.Create('compile_string');
  if @execute = nil then raise EPHP4DelphiException.Create('execute');
  if @zend_wrong_param_count = nil then raise EPHP4DelphiException.Create('zend_wrong_param_count');
  if @add_property_long_ex = nil then raise EPHP4DelphiException.Create('add_property_long_ex');
  if @add_property_null_ex = nil then raise EPHP4DelphiException.Create('add_property_null_ex');
  if @add_property_bool_ex = nil then raise EPHP4DelphiException.Create('add_property_bool_ex');
  if @add_property_resource_ex = nil then raise EPHP4DelphiException.Create('add_property_resource_ex');
  if @add_property_double_ex = nil then raise EPHP4DelphiException.Create('add_property_double_ex');
  if @add_property_string_ex = nil then raise EPHP4DelphiException.Create('add_property_string_ex');
  if @add_property_stringl_ex = nil then raise EPHP4DelphiException.Create('add_property_stringl_ex');
  if @add_property_zval_ex = nil then raise EPHP4DelphiException.Create('add_property_zval_ex');
  if @add_assoc_long_ex = nil then raise EPHP4DelphiException.Create('add_assoc_long_ex');
  if @add_assoc_null_ex = nil then raise EPHP4DelphiException.Create('add_assoc_null_ex');
  if @add_assoc_bool_ex = nil then raise EPHP4DelphiException.Create('add_assoc_bool_ex');
  if @add_assoc_resource_ex = nil then raise EPHP4DelphiException.Create('add_assoc_resource_ex');
  if @add_assoc_double_ex = nil then raise EPHP4DelphiException.Create('add_assoc_double_ex');
  if @add_assoc_string_ex = nil then raise EPHP4DelphiException.Create('add_assoc_string_ex');
  if @add_assoc_stringl_ex = nil then raise EPHP4DelphiException.Create('add_assoc_stringl_ex');
  if @add_assoc_zval_ex = nil then raise EPHP4DelphiException.Create('add_assoc_zval_ex');
  if @add_index_long = nil then raise EPHP4DelphiException.Create('add_index_long');
  if @add_index_null = nil then raise EPHP4DelphiException.Create('add_index_null');
  if @add_index_bool = nil then raise EPHP4DelphiException.Create('add_index_bool');
  if @add_index_resource = nil then raise EPHP4DelphiException.Create('add_index_resource');
  if @add_index_double = nil then raise EPHP4DelphiException.Create('add_index_double');
  if @add_index_string = nil then raise EPHP4DelphiException.Create('add_index_string');
  if @add_index_stringl = nil then raise EPHP4DelphiException.Create('add_index_stringl');
  if @add_index_zval = nil then raise EPHP4DelphiException.Create('add_index_zval');
  if @add_next_index_long = nil then raise EPHP4DelphiException.Create('add_next_index_long');
  if @add_next_index_null = nil then raise EPHP4DelphiException.Create('add_next_index_null');
  if @add_next_index_bool = nil then raise EPHP4DelphiException.Create('add_next_index_bool');
  if @add_next_index_resource = nil then raise EPHP4DelphiException.Create('add_next_index_resource');
  if @add_next_index_double = nil then raise EPHP4DelphiException.Create('add_next_index_double');
  if @add_next_index_string = nil then raise EPHP4DelphiException.Create('add_next_index_string');
  if @add_next_index_stringl = nil then raise EPHP4DelphiException.Create('add_next_index_stringl');
  if @add_next_index_zval = nil then raise EPHP4DelphiException.Create('add_next_index_zval');
  if @add_get_assoc_string_ex = nil then raise EPHP4DelphiException.Create('add_get_assoc_string_ex');
  if @add_get_assoc_stringl_ex = nil then raise EPHP4DelphiException.Create('add_get_assoc_stringl_ex');
  if @add_get_index_long = nil then raise EPHP4DelphiException.Create('add_get_index_long');
  if @add_get_index_double = nil then raise EPHP4DelphiException.Create('add_get_index_double');
  if @add_get_index_string = nil then raise EPHP4DelphiException.Create('add_get_index_string');
  if @add_get_index_stringl = nil then raise EPHP4DelphiException.Create('add_get_index_stringl');
  if @_array_init = nil then raise EPHP4DelphiException.Create('_array_init');
  if @_object_init = nil then raise EPHP4DelphiException.Create('_object_init');
  if @_object_init_ex = nil then raise EPHP4DelphiException.Create('_object_init_ex');
  if @_object_and_properties_init = nil then raise EPHP4DelphiException.Create('_object_and_properties_init');
  if @zend_register_internal_class = nil then raise EPHP4DelphiException.Create('zend_register_internal_class');
  if @zend_register_internal_class_ex = nil then raise EPHP4DelphiException.Create('zend_register_internal_class_ex');
  if @get_zend_version = nil then raise EPHP4DelphiException.Create('get_zend_version');
  if @zend_make_printable_zval = nil then raise EPHP4DelphiException.Create('zend_make_printable_zval');
  if @zend_print_zval = nil then raise EPHP4DelphiException.Create('zend_print_zval');
  if @zend_print_zval_r = nil then raise EPHP4DelphiException.Create('zend_print_zval_r');
  if @zend_output_debug_string = nil then raise EPHP4DelphiException.Create('zend_output_debug_string');
  if @ZendGetParameters = nil then raise EPHP4DelphiException.Create('zend_get_parameters');
  {$ELSE}
  if @tsrm_startup = nil then ReportLinkError('tsrm_startup');
  if @ts_allocate_id = nil then ReportLinkError('ts_allocate_id');
  if @ts_free_id = nil then ReportLinkError('ts_free_id');
  if @zend_strndup = nil then ReportLinkError('zend_strndup');
  if @_emalloc = nil then ReportLinkError('_emalloc');
  if @_efree = nil then ReportLinkError('_efree');
  if @_ecalloc = nil then ReportLinkError('_ecalloc');
  if @_erealloc = nil then ReportLinkError('_erealloc');
  if @_estrdup = nil then ReportLinkError('_estrdup');
  if @_estrndup = nil then ReportLinkError('_estrndup');
  if @zend_set_memory_limit = nil then ReportLinkError('zend_set_memory_limit');
  if @start_memory_manager = nil then ReportLinkError('start_memory_manager');
  if @shutdown_memory_manager = nil then ReportLinkError('shutdown_memory_manager');
  if @zend_hash_init = nil then ReportLinkError('zend_hash_init');
  if @zend_hash_init_ex = nil then ReportLinkError('zend_hash_init_ex');
  if @zend_hash_destroy = nil then ReportLinkError('zend_hash_destroy');
  if @zend_hash_clean = nil then ReportLinkError('zend_hash_clean');
  if @zend_hash_add_or_update = nil then ReportLinkError('zend_hash_add_or_update');
  if @zend_hash_quick_add_or_update = nil then ReportLinkError('zend_hash_quick_add_or_update');
  if @zend_hash_index_update_or_next_insert = nil then ReportLinkError('zend_hash_index_update_or_next_insert');
  if @zend_hash_add_empty_element = nil then ReportLinkError('zend_hash_add_empty_element');
  if @zend_hash_graceful_destroy = nil then ReportLinkError('zend_hash_graceful_destroy');
  if @zend_hash_graceful_reverse_destroy = nil then ReportLinkError('zend_hash_graceful_reverse_destroy');
  if @zend_hash_apply = nil then ReportLinkError('zend_hash_apply');
  if @zend_hash_apply_with_argument = nil then ReportLinkError('zend_hash_apply_with_argument');
  if @zend_hash_reverse_apply = nil then ReportLinkError('zend_hash_reverse_apply');
  if @zend_hash_del_key_or_index = nil then ReportLinkError('zend_hash_del_key_or_index');
  if @zend_get_hash_value = nil then ReportLinkError('zend_get_hash_value');
  if @zend_hash_find = nil then ReportLinkError('zend_hash_find');
  if @zend_hash_quick_find = nil then ReportLinkError('zend_hash_quick_find');
  if @zend_hash_index_find = nil then ReportLinkError('zend_hash_index_find');
  if @zend_hash_exists = nil then ReportLinkError('zend_hash_exists');
  if @zend_hash_index_exists = nil then ReportLinkError('zend_hash_index_exists');
  if @zend_hash_next_free_element = nil then ReportLinkError('zend_hash_next_free_element');
  if @zend_hash_move_forward_ex = nil then ReportLinkError('zend_hash_move_forward_ex');
  if @zend_hash_move_backwards_ex = nil then ReportLinkError('zend_hash_move_backwards_ex');
  if @zend_hash_get_current_key_ex = nil then ReportLinkError('zend_hash_get_current_key_ex');
  if @zend_hash_get_current_key_type_ex = nil then ReportLinkError('zend_hash_get_current_key_type_ex');
  if @zend_hash_get_current_data_ex = nil then ReportLinkError('zend_hash_get_current_data_ex');
  if @zend_hash_internal_pointer_reset_ex = nil then ReportLinkError('zend_hash_internal_pointer_reset_ex');
  if @zend_hash_internal_pointer_end_ex = nil then ReportLinkError('zend_hash_internal_pointer_end_ex');
  if @zend_hash_copy = nil then ReportLinkError('zend_hash_copy');
  if @zend_hash_merge = nil then ReportLinkError('zend_hash_merge');
  if @zend_hash_sort = nil then ReportLinkError('zend_hash_sort');
  if @zend_hash_compare = nil then ReportLinkError('zend_hash_compare');
  if @zend_hash_minmax = nil then ReportLinkError('zend_hash_minmax');
  if @zend_hash_num_elements = nil then ReportLinkError('zend_hash_num_elements');
  if @zend_hash_rehash = nil then ReportLinkError('zend_hash_rehash');
  if @zend_hash_func = nil then ReportLinkError('zend_hash_func');
  if @zend_get_constant = nil then ReportLinkError('zend_get_constant');
  if @zend_register_long_constant = nil then ReportLinkError('zend_register_long_constant');
  if @zend_register_double_constant = nil then ReportLinkError('zend_register_double_constant');
  if @zend_register_string_constant = nil then ReportLinkError('zend_register_string_constant');
  if @zend_register_stringl_constant = nil then ReportLinkError('zend_register_stringl_constant');
  if @zend_register_constant = nil then ReportLinkError('zend_register_constant');
  if @tsrm_shutdown = nil then ReportLinkError('tsrm_shutdown');
  if @ts_resource_ex = nil then ReportLinkError('ts_resource_ex');
  if @ts_free_thread = nil then ReportLinkError('ts_free_thread');
  if @zend_error = nil then ReportLinkError('zend_error');
  if @zend_error_cb = nil then ReportLinkError('zend_error_cb');
  if @zend_eval_string = nil then ReportLinkError('zend_eval_string');
  if @zend_make_compiled_string_description = nil then ReportLinkError('zend_make_compiled_string_description');
  if @_zval_dtor = nil then ReportLinkError('_zval_dtor');
  if @_zval_copy_ctor = nil then ReportLinkError('_zval_copy_ctor');
  if @zend_print_variable = nil then ReportLinkError('zend_print_variable');
  if @zend_stack_init = nil then ReportLinkError('zend_stack_init');
  if @zend_stack_push = nil then ReportLinkError('zend_stack_push');
  if @zend_stack_top = nil then ReportLinkError('zend_stack_top');
  if @zend_stack_del_top = nil then ReportLinkError('zend_stack_del_top');
  if @zend_stack_int_top = nil then ReportLinkError('zend_stack_int_top');
  if @zend_stack_is_empty = nil then ReportLinkError('zend_stack_is_empty');
  if @zend_stack_destroy = nil then ReportLinkError('zend_stack_destroy');
  if @zend_stack_base = nil then ReportLinkError('zend_stack_base');
  if @zend_stack_count = nil then ReportLinkError('zend_stack_count');
  if @zend_stack_apply = nil then ReportLinkError('zend_stack_apply');
  if @zend_stack_apply_with_argument = nil then ReportLinkError('zend_stack_apply_with_argument');
  if @_convert_to_string = nil then ReportLinkError('_convert_to_string');
  if @add_function = nil then ReportLinkError('add_function');
  if @sub_function = nil then ReportLinkError('sub_function');
  if @mul_function = nil then ReportLinkError('mul_function');
  if @div_function = nil then ReportLinkError('div_function');
  if @mod_function = nil then ReportLinkError('mod_function');
  if @boolean_xor_function = nil then ReportLinkError('boolean_xor_function');
  if @boolean_not_function = nil then ReportLinkError('boolean_not_function');
  if @bitwise_not_function = nil then ReportLinkError('bitwise_not_function');
  if @bitwise_or_function = nil then ReportLinkError('bitwise_or_function');
  if @bitwise_and_function = nil then ReportLinkError('bitwise_and_function');
  if @bitwise_xor_function = nil then ReportLinkError('bitwise_xor_function');
  if @shift_left_function = nil then ReportLinkError('shift_left_function');
  if @shift_right_function = nil then ReportLinkError('shift_right_function');
  if @concat_function = nil then ReportLinkError('concat_function');
  if @is_equal_function = nil then ReportLinkError('is_equal_function');
  if @is_identical_function = nil then ReportLinkError('is_identical_function');
  if @is_not_identical_function = nil then ReportLinkError('is_not_identical_function');
  if @is_not_equal_function = nil then ReportLinkError('is_not_equal_function');
  if @is_smaller_function = nil then ReportLinkError('is_smaller_function');
  if @is_smaller_or_equal_function = nil then ReportLinkError('is_smaller_or_equal_function');
  if @increment_function = nil then ReportLinkError('increment_function');
  if @decrement_function = nil then ReportLinkError('decrement_function');
  if @convert_scalar_to_number = nil then ReportLinkError('convert_scalar_to_number');
  if @convert_to_long = nil then ReportLinkError('convert_to_long');
  if @convert_to_double = nil then ReportLinkError('convert_to_double');
  if @convert_to_long_base = nil then ReportLinkError('convert_to_long_base');
  if @convert_to_null = nil then ReportLinkError('convert_to_null');
  if @convert_to_boolean = nil then ReportLinkError('convert_to_boolean');
  if @convert_to_array = nil then ReportLinkError('convert_to_array');
  if @convert_to_object = nil then ReportLinkError('convert_to_object');
  if @add_char_to_string = nil then ReportLinkError('add_char_to_string');
  if @add_string_to_string = nil then ReportLinkError('add_string_to_string');
  if @zend_string_to_double = nil then ReportLinkError('zend_string_to_double');
  if @zval_is_true = nil then ReportLinkError('zval_is_true');
  if @compare_function = nil then ReportLinkError('compare_function');
  if @numeric_compare_function = nil then ReportLinkError('numeric_compare_function');
  if @string_compare_function = nil then ReportLinkError('string_compare_function');
  if @zend_str_tolower = nil then ReportLinkError('zend_str_tolower');
  if @zend_binary_zval_strcmp = nil then ReportLinkError('zend_binary_zval_strcmp');
  if @zend_binary_zval_strncmp = nil then ReportLinkError('zend_binary_zval_strncmp');
  if @zend_binary_zval_strcasecmp = nil then ReportLinkError('zend_binary_zval_strcasecmp');
  if @zend_binary_zval_strncasecmp = nil then ReportLinkError('zend_binary_zval_strncasecmp');
  if @zend_binary_strcmp = nil then ReportLinkError('zend_binary_strcmp');
  if @zend_binary_strncmp = nil then ReportLinkError('zend_binary_strncmp');
  if @zend_binary_strcasecmp = nil then ReportLinkError('zend_binary_strcasecmp');
  if @zend_binary_strncasecmp = nil then ReportLinkError('zend_binary_strncasecmp');
  if @zendi_smart_strcmp = nil then ReportLinkError('zendi_smart_strcmp');
  if @zend_compare_symbol_tables = nil then ReportLinkError('zend_compare_symbol_tables');
  if @zend_compare_arrays = nil then ReportLinkError('zend_compare_arrays');
  if @zend_compare_objects = nil then ReportLinkError('zend_compare_objects');
  if @zend_atoi = nil then ReportLinkError('zend_atoi');
  if @get_active_function_name = nil then ReportLinkError('get_active_function_name');
  if @zend_get_executed_filename = nil then ReportLinkError('zend_get_executed_filename');
  if @zend_set_timeout = nil then ReportLinkError('zend_set_timeout');
  if @zend_unset_timeout = nil then ReportLinkError('zend_unset_timeout');
  if @zend_timeout = nil then ReportLinkError('zend_timeout');
  if @zend_highlight = nil then ReportLinkError('zend_highlight');
  if @zend_strip = nil then ReportLinkError('zend_strip');
  if @highlight_file = nil then ReportLinkError('highlight_file');
  if @highlight_string = nil then ReportLinkError('highlight_string');
  if @zend_html_putc = nil then ReportLinkError('zend_html_putc');
  if @zend_html_puts = nil then ReportLinkError('zend_html_puts');
  if @zend_indent = nil then ReportLinkError('zend_indent');
  if @_zend_get_parameters_array_ex = nil then ReportLinkError('_zend_get_parameters_array_ex');
  if @zend_ini_refresh_caches = nil then ReportLinkError('zend_ini_refresh_caches');
  if @zend_alter_ini_entry = nil then ReportLinkError('zend_alter_ini_entry');
  if @zend_restore_ini_entry = nil then ReportLinkError('zend_restore_ini_entry');
  if @zend_ini_long = nil then ReportLinkError('zend_ini_long');
  if @zend_ini_double = nil then ReportLinkError('zend_ini_double');
  if @zend_ini_string = nil then ReportLinkError('zend_ini_string');
  if @compile_string = nil then ReportLinkError('compile_string');
  if @execute = nil then ReportLinkError('execute');
  if @zend_wrong_param_count = nil then ReportLinkError('zend_wrong_param_count');
  if @add_property_long_ex = nil then ReportLinkError('add_property_long_ex');
  if @add_property_null_ex = nil then ReportLinkError('add_property_null_ex');
  if @add_property_bool_ex = nil then ReportLinkError('add_property_bool_ex');
  if @add_property_resource_ex = nil then ReportLinkError('add_property_resource_ex');
  if @add_property_double_ex = nil then ReportLinkError('add_property_double_ex');
  if @add_property_string_ex = nil then ReportLinkError('add_property_string_ex');
  if @add_property_stringl_ex = nil then ReportLinkError('add_property_stringl_ex');
  if @add_property_zval_ex = nil then ReportLinkError('add_property_zval_ex');
  if @add_assoc_long_ex = nil then ReportLinkError('add_assoc_long_ex');
  if @add_assoc_null_ex = nil then ReportLinkError('add_assoc_null_ex');
  if @add_assoc_bool_ex = nil then ReportLinkError('add_assoc_bool_ex');
  if @add_assoc_resource_ex = nil then ReportLinkError('add_assoc_resource_ex');
  if @add_assoc_double_ex = nil then ReportLinkError('add_assoc_double_ex');
  if @add_assoc_string_ex = nil then ReportLinkError('add_assoc_string_ex');
  if @add_assoc_stringl_ex = nil then ReportLinkError('add_assoc_stringl_ex');
  if @add_assoc_zval_ex = nil then ReportLinkError('add_assoc_zval_ex');
  if @add_index_long = nil then ReportLinkError('add_index_long');
  if @add_index_null = nil then ReportLinkError('add_index_null');
  if @add_index_bool = nil then ReportLinkError('add_index_bool');
  if @add_index_resource = nil then ReportLinkError('add_index_resource');
  if @add_index_double = nil then ReportLinkError('add_index_double');
  if @add_index_string = nil then ReportLinkError('add_index_string');
  if @add_index_stringl = nil then ReportLinkError('add_index_stringl');
  if @add_index_zval = nil then ReportLinkError('add_index_zval');
  if @add_next_index_long = nil then ReportLinkError('add_next_index_long');
  if @add_next_index_null = nil then ReportLinkError('add_next_index_null');
  if @add_next_index_bool = nil then ReportLinkError('add_next_index_bool');
  if @add_next_index_resource = nil then ReportLinkError('add_next_index_resource');
  if @add_next_index_double = nil then ReportLinkError('add_next_index_double');
  if @add_next_index_string = nil then ReportLinkError('add_next_index_string');
  if @add_next_index_stringl = nil then ReportLinkError('add_next_index_stringl');
  if @add_next_index_zval = nil then ReportLinkError('add_next_index_zval');
  if @add_get_assoc_string_ex = nil then ReportLinkError('add_get_assoc_string_ex');
  if @add_get_assoc_stringl_ex = nil then ReportLinkError('add_get_assoc_stringl_ex');
  if @add_get_index_long = nil then ReportLinkError('add_get_index_long');
  if @add_get_index_double = nil then ReportLinkError('add_get_index_double');
  if @add_get_index_string = nil then ReportLinkError('add_get_index_string');
  if @add_get_index_stringl = nil then ReportLinkError('add_get_index_stringl');
  if @_array_init = nil then ReportLinkError('_array_init');
  if @_object_init = nil then ReportLinkError('_object_init');
  if @_object_init_ex = nil then ReportLinkError('_object_init_ex');
  if @_object_and_properties_init = nil then ReportLinkError('_object_and_properties_init');
  if @zend_register_internal_class = nil then ReportLinkError('zend_register_internal_class');
  if @zend_register_internal_class_ex = nil then ReportLinkError('zend_register_internal_class_ex');
  if @get_zend_version = nil then ReportLinkError('get_zend_version');
  if @zend_make_printable_zval = nil then ReportLinkError('zend_make_printable_zval');
  if @zend_print_zval = nil then ReportLinkError('zend_print_zval');
  if @zend_print_zval_r = nil then ReportLinkError('zend_print_zval_r');
  if @zend_output_debug_string = nil then ReportLinkError('zend_output_debug_string');
  if @ZendGetParameters = nil then ReportLinkError('zend_get_parameters');
  {$ENDIF}
end;


function zend_hash_get_current_data(ht: PHashTable; pData: Pointer): Integer; cdecl;
begin
  result := zend_hash_get_current_data_ex(ht, pData, nil);
end;

procedure zend_hash_internal_pointer_reset(ht: PHashTable); cdecl;
begin
  zend_hash_internal_pointer_reset_ex(ht, nil);
end;

function ts_resource(id : integer) : pointer;
begin
  result := ts_resource_ex(id, nil);
end;

initialization
{$IFDEF PHP4DELPHI_AUTOLOAD}
  LoadZEND;
{$ENDIF}

finalization
{$IFDEF PHP4DELPHI_AUTOUNLOAD}
  UnloadZEND;
{$ENDIF}

end.


