{ $Id: php4AppUnit.pas,v 5.3 2003/11/21 18:09:18 delphi32 Exp $ }
unit php4AppUnit;

interface
uses
  Windows,
  SysUtils,
  Classes,
  PHPAPI,
  ZENDAPI;

type
 TWriteClientProc = procedure(c : char); stdcall;
 TModuleShutdownWrapper = function (globals : pointer) : Integer; cdecl;

var
  delphi_sapi_module : sapi_module_struct;
  php_delphi_module : Tzend_module_entry;
  wri_func : TWriteClientProc;
  VarList : TStringList;

function GetArray : pchar; stdcall;
procedure RegisterVariable(AName : PChar; AValue : PChar); stdcall;
function ExecutePHP(FileName : PChar; callback_proc : pointer) : integer; stdcall;
function ExecuteCode(ACode : PChar; callback_proc : pointer) : integer; stdcall;
procedure PrepareStartup;

implementation


procedure php_info_delphi(zend_module : Pointer; TSRMLS_DC : pointer); cdecl;
begin
  php_info_print_table_start();
  php_info_print_table_row(2, PChar('SAPI module version'), PChar('PHP4Delphi 5.3 Nov 2003'));
  php_info_print_table_row(2, PChar('Home page'), PChar('http://users.chello.be/ws36637'));
  php_info_print_table_end();
end;

function php_delphi_startup(sapi_module : pointer) : integer; cdecl;
begin
  result := php_module_startup(sapi_module, nil, 0);
end;

function php_delphi_deactivate(p : pointer) : integer; cdecl;
begin
  result := 0;
end;


function php_delphi_ub_write(str : pchar; len : uint; p : pointer) : integer; cdecl;
var
 i : integer;
begin
  for i := 0 to len-1 do
   wri_func(str[i]);
  Result := len;
end;


procedure php_delphi_register_variables(val : pzval; p : pointer); cdecl;
var
 cnt : integer;
begin
  php_register_variable('SERVER_NAME','DELPHI', val, p);
  php_register_variable('SERVER_SOFTWARE', 'Delphi', val, p);
  for cnt := 0 to VarList.Count - 1 do
     begin
         php_register_variable(PChar(VarList.Names[cnt]),
                PChar(VarList.Values[VarList.Names[cnt]]), val, p);
    end;
end;


procedure php_delphi_send_header(p1, p2, p3 : pointer); cdecl;
begin
  //
end;

function php_delphi_read_cookies(p1 : pointer) : pointer; cdecl;
begin
  result := nil;
end;




procedure PrepareStartup;
begin
  delphi_sapi_module.name := 'php4delphi';  (* name *)
  delphi_sapi_module.pretty_name := 'PHP for Delphi';  (* pretty name *)
  delphi_sapi_module.startup := @php_delphi_startup;    (* startup *)
  delphi_sapi_module.shutdown := @php_module_shutdown_wrapper;   (* shutdown *)
  delphi_sapi_module.activate:= nil;  (* activate *)
  delphi_sapi_module.deactivate := @php_delphi_deactivate;  (* deactivate *)
  delphi_sapi_module.ub_write := @php_delphi_ub_write;      (* unbuffered write *)
  delphi_sapi_module.flush := nil;
  delphi_sapi_module.stat:= nil;
  delphi_sapi_module.getenv:= nil;
  delphi_sapi_module.sapi_error := @zend_error;  (* error handler *)
  delphi_sapi_module.header_handler := nil;
  delphi_sapi_module.send_headers := nil;
  delphi_sapi_module.send_header :=  @php_delphi_send_header;
  delphi_sapi_module.read_post := nil;
  delphi_sapi_module.read_cookies := @php_delphi_read_cookies;
  delphi_sapi_module.register_server_variables := @php_delphi_register_variables;   (* register server variables *)
  delphi_sapi_module.log_message := nil;  (* Log message *)
  delphi_sapi_module.php_ini_path_override := nil;
  delphi_sapi_module.block_interruptions := nil;
  delphi_sapi_module.unblock_interruptions := nil;
  delphi_sapi_module.default_post_reader := nil;
  delphi_sapi_module.treat_data := 0;
  delphi_sapi_module.executable_location := nil;
  delphi_sapi_module.php_ini_ignore := 0;

  php_delphi_module.size := sizeOf(Tzend_module_entry);
  php_delphi_module.zend_api := ZEND_MODULE_API_NO;
  php_delphi_module.zend_debug := 0;
  php_delphi_module.zts := USING_ZTS;
  php_delphi_module.name := 'php4delphi_support';
  php_delphi_module.functions := nil;
  php_delphi_module.module_startup_func := nil;
  php_delphi_module.module_shutdown_func := nil;
  php_delphi_module.info_func := @php_info_delphi;
  php_delphi_module.version := '5.0.2';
  php_delphi_module.global_startup_func := nil;
  php_delphi_module.request_shutdown_func := nil;
  php_delphi_module.global_id := 0;
  php_delphi_module.module_started := 0;
  php_delphi_module._type := 0;
  php_delphi_module.handle := nil;
  php_delphi_module.module_number := 0;
end;


procedure DLLHandler(fdwReason : integer);
begin
  case fdwReason of
   DLL_PROCESS_ATTACH :
     begin
       LoadPHP;
       PrepareStartup;
       tsrm_startup(1, 1, TSRM_ERROR_LEVEL_CORE, 'TSRM.log');
       sapi_startup(@delphi_sapi_module);
       php_module_startup(@delphi_sapi_module, @php_delphi_module, 1);
       VarList := TStringList.Create;
     end;
    DLL_THREAD_DETACH:
      begin
        ts_free_thread;
        VarList.Clear;
      end;
    DLL_PROCESS_DETACH:
      begin
        delphi_sapi_module.shutdown(@delphi_sapi_module);
        tsrm_shutdown(nil);
        VarList.Free;
        UnloadPHP;
      end;
  end;
end;



procedure PrepareResult(TSRMLS_D : pointer);
var
  ht  : PHashTable;
  data: ^ppzval;
  cnt : integer;
begin
  ht := GetSymbolsTable(TSRMLS_D);
  if Assigned(ht) then
   begin
     for cnt := 0 to VarList.Count - 1  do
      begin
        new(data);
        try
          if zend_hash_find(ht, PChar(VarList.Names[cnt]),
          strlen(PChar(VarList.Names[cnt])) + 1, data) = SUCCESS then
          case data^^^._type of
            IS_STRING : VarList.Values[VarList.Names[cnt]] := data^^^.value.str.val;
            IS_LONG,
            IS_RESOURCE,
            IS_BOOL   : VarList.Values[VarList.Names[cnt]] := IntToStr(data^^^.value.lval);
            IS_DOUBLE : VarList.Values[VarList.Names[cnt]] := FloatToStr(data^^^.value.dval);
          end;
        finally
          freemem(data);
        end;
      end;
   end;
end;

function ExecutePHP(FileName : PChar; callback_proc : pointer) : integer; stdcall;
var
  file_handle : zend_file_handle;
  TSRMLS_D : pointer;
begin
  @wri_func := callback_proc;
  TSRMLS_D := ts_resource_ex(0, nil);
  file_handle._type := ZEND_HANDLE_FILENAME;
  file_handle.filename := FileName;
  file_handle.opened_path := nil;
  file_handle.free_filename := 0;
  php_request_startup(TSRMLS_D);
  result := php_execute_script(@file_handle, TSRMLS_D);
  PrepareResult(TSRMLS_D);
  php_request_shutdown(nil);
end;


function ExecuteCode(ACode : PChar; callback_proc : pointer) : integer; stdcall;
var
  TSRMLS_D : pointer;
  compiled_string : pchar;
begin
  @wri_func := callback_proc;
  TSRMLS_D := ts_resource_ex(0, nil);
  php_request_startup(TSRMLS_D);
  compiled_string := zend_make_compiled_string_description('embedded', TSRMLS_D );
  result := zend_eval_string(PChar(ACode), nil, compiled_string, TSRMLS_D);
  PrepareResult(TSRMLS_D);
  efree(compiled_string);
  php_request_shutdown(nil);
end;


procedure RegisterVariable(AName : PChar; AValue : PChar); stdcall;
begin
  if Assigned(VarList) then
   VarList.Add(AName + '=' + AValue);
end;

function GetArray : pchar; stdcall;
begin
  if Assigned(VarList) then
   begin
    Result := VarList.GetText;
    VarList.Clear;
   end
      else
        Result := nil;
end;


initialization
  DLLProc := @DLLHandler;

end.